define("app/fight",function(require,exports,module){
"use strict";

var _scene = _interopRequireDefault(require("libs/ni/scene"));

var _frame = _interopRequireDefault(require("libs/ni/frame"));

var _db = _interopRequireDefault(require("libs/ni/db"));

var _widget = _interopRequireDefault(require("libs/ni/widget"));

var _cfgmrg = _interopRequireDefault(require("libs/ni/cfgmrg"));

var _appEmitter = require("app/appEmitter");

var _connect = _interopRequireDefault(require("libs/ni/connect"));

var _stage = require("app/stage");

var _global = require("app/global");

var _music = _interopRequireDefault(require("libs/ni/music"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/****************** 导出 ******************/

/****************** 本地 ******************/
var lastFace,
    //上一个界面
enemyType,
    //敌人种类,-1是入侵的，0,1,2代表第几个据点
faceName = ["intoScience", "intoPeople", "intoBuild", "intoArmy", "intoMap"],
    fighter,
    //参战数据[[[id,num,add+1,位置,兵种],[己方]],[[敌方],[方]]]
hpNode = [[]],
    //扣血节点
numberNode = [[]],
    //军队人数节点
moverF = [],
    //当前精灵阵营，ID
moverT = [],
    //目标精灵阵营，ID
sitP = [],
    //军队不动时坐标
attP = [],
    //进队进攻的坐标          
fighter_sprite = [[]],
    //参战军队精灵
armys = [[]],
    //参战军队的逻辑对象
state,
    //表现演播的状态
isvic,
    //是否胜利
fight_show,
    // 战斗表现
armysF,
    //当前军队逻辑对象
armysT,
    //目标军队逻辑对象  
damage,
    //伤害
vx,
    //水平移动速度
vy,
    //竖直移动速度
damageSprite = [],
    //伤害飘字
damageNode = [],
    //伤害飘字
kill_die,
    //我军将领杀敌损伤
cityId,
    //争夺城市的ID
hero_news = [[], []],
    //将领打后需要播报的情况  负伤/提升
fa9_army = 0,
    //离间增加的士兵人数 
isfa12 = 0; //是否有群英荟萃效果    

var Fight =
/*#__PURE__*/
function () {
  function Fight() {
    _classCallCheck(this, Fight);
  }

  _createClass(Fight, null, [{
    key: "run",
    //事件列表
    //震动次数
    //震动阶段
    value: function run() {
      //动画播报
      if (Date.now() > Fight.nextFrame) {
        if (state == "start") {
          moverF = sitP[fight_show[0][1]][fight_show[0][2]];
          moverT = attP[fight_show[0][4]][fight_show[0][5]];
          armysF = armys[fight_show[0][1]][fight_show[0][2]];
          armysT = armys[fight_show[0][4]][fight_show[0][5]];
          damage = fight_show[0][6];
          vx = (moverT[0] - moverF[0]) / 20;
          vy = (moverT[1] - moverF[1]) / 20;
          state = "run1";
        } else if (state == "run1") {
          if (armysF.top >= moverT[1] && vy >= 0 || armysF.top <= moverT[1] && vy <= 0) {
            state = "damage"; //战斗报文fight_show[攻武将ID，攻阵营，攻位置，防武将ID，防阵营，防位置，死伤数]

            var character = ["A引军袭杀B", "A与B交战", "A与B遭遇，战至一处", "A伏击B", "A直取B大营", "A驱兵攻B", "A截住B去路"],
                result = ["斩首", "杀敌", "斩敌", "削首", "歼敌"],
                bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
                str = "".concat(character[(0, _global.rand)(character.length) - 1], ",").concat(result[(0, _global.rand)(result.length) - 1]).concat(fight_show[0][6]);

            str = str.replace("A", "".concat(bcfg[fight_show[0][0]]["name"]));
            str = str.replace("B", "".concat(bcfg[fight_show[0][3]]["name"]));
            (0, _stage.addFNews)("".concat(fight_show[0][1] * 4 + 2).concat(str, "\u4EBA\u3002"));

            if (isfa12 && fight_show[0][1]) {
              for (var i = 0; i < 3; i++) {
                if (armys[0][i].hp > 0) {
                  if (damageSprite[i] && damageSprite[i].parent) {
                    damageSprite[i].ni.left = armys[0][i].left;
                    damageSprite[i].ni.top = armys[0][i].top + 10;
                    damageNode[i].text = "-".concat(Math.ceil(damage / 3));
                  } else {
                    damageSprite[i] = _scene.default.open("app-ui-fightHp", _global.Global.mainFace.node, null, {
                      left: armys[0][i].left,
                      top: armys[0][i].top + 10,
                      damage: Math.ceil(damage / 3),
                      index: i
                    });
                  }
                }
              }
            } else {
              if (damageSprite[0] && damageSprite[0].parent) {
                damageSprite[0].ni.left = armysT.left;
                damageSprite[0].ni.top = armysT.top + 10;
                damageNode[0].text = "-".concat(damage);
              } else {
                damageSprite[0] = _scene.default.open("app-ui-fightHp", _global.Global.mainFace.node, null, {
                  left: armysT.left,
                  top: armysT.top + 10,
                  damage: damage,
                  index: 0
                });
              }
            }
          } else {
            armysF.left += vx;
            armysF.top += vy;
            Fight.events.push({
              type: "move",
              target: armysF
            });
          }
        } else if (state == "damage") {
          if (!Fight.mp3) {
            _music.default.play("audio/attck.mp3");

            Fight.mp3 = 1;
          }

          if (Fight.shake > 0) {
            //判断群英荟萃
            if (isfa12 && fight_show[0][1]) {
              var first = 1,
                  first1 = 1;

              for (var _i = 0; _i < 3; _i++) {
                if (armys[0][_i].hp > 0) {
                  damageSprite[_i].ni.top += 1;

                  if (Fight.shakeState > -5) {
                    armys[0][_i].left += Fight.shakeState / (Math.abs(Fight.shakeState) ? Math.abs(Fight.shakeState) : 1);
                    Fight.shakeState -= 1 * first;
                    first = 0;
                    Fight.events.push({
                      type: "move",
                      target: armys[0][_i]
                    });
                  } else {
                    Fight.shake -= 1 * first1;
                    first1 = 0;
                    Fight.shakeState = 4;
                  }
                }
              }
            } else {
              damageSprite[0].ni.top += 1;

              if (Fight.shakeState > -5) {
                armysT.left += Fight.shakeState / (Math.abs(Fight.shakeState) ? Math.abs(Fight.shakeState) : 1);
                Fight.shakeState -= 1;
                Fight.events.push({
                  type: "move",
                  target: armysT
                });
              } else {
                Fight.shake -= 1;
                Fight.shakeState = 4;
              }
            }
          } else {
            var Cname = ["步", "骑", "弓"];
            Fight.shake = 3;
            state = "run2"; //判断群英荟萃

            if (isfa12 && fight_show[0][1]) {
              for (var _i2 = 0; _i2 < 3; _i2++) {
                if (armys[0][_i2].hp > 0) {
                  armys[0][_i2].hp = armys[0][_i2].hp - Math.ceil(damage / 3) < 0 ? 0 : armys[0][_i2].hp - Math.ceil(damage / 3);
                  numberNode[0][_i2].text = "".concat(armys[0][_i2].hp, " ").concat(Cname[fighter[0][_i2][4]]);
                  hpNode[0][_i2].scale.y = armys[0][_i2].hp / armys[0][_i2].max_hp;
                  damageSprite[_i2].ni.top += 2000;
                }
              }
            } else {
              armysT.hp -= damage;
              numberNode[fight_show[0][4]][fight_show[0][5]].text = "".concat(armysT.hp, " ").concat(Cname[fighter[fight_show[0][4]][fight_show[0][5]][4]]);
              hpNode[fight_show[0][4]][fight_show[0][5]].scale.y = armysT.hp / armysT.max_hp;
              damageSprite[0].ni.top += 2000;
            }
          }
        } else if (state == "run2") {
          Fight.mp3 = 0;

          if (armysF.top >= moverF[1] && vy <= 0 || armysF.top <= moverF[1] && vy >= 0) {
            fight_show.splice(0, 1);

            if (fight_show[0]) {
              state = "start";
            } else {
              state = "end";
            }
          } else {
            armysF.left -= vx;
            armysF.top -= vy;
            Fight.events.push({
              type: "move",
              target: armysF
            });
          }
        } else if (state == "end") {
          _scene.default.open("app-ui-fightAccount", _global.Global.mainFace.node);

          state = "";
        }

        Fight.nextFrame += Fight.time;
      }
    }
  }, {
    key: "loop",
    value: function loop() {
      var evs;

      if (!Fight.pause) {
        Fight.run();
      }

      evs = Fight.events;
      Fight.events = [];
      return evs;
    }
  }]);

  return Fight;
}();

Fight.pause = 1;
Fight.events = [];
Fight.shake = 3;
Fight.shakeState = 4;
Fight.mp3 = 0;
Fight.nextFrame = void 0;
Fight.time = 17;

var Army = function Army(options) {
  _classCallCheck(this, Army);

  this.top = 0;
  this.left = 0;
  this.hp = 0;
  this.max_hp = 0;
  this.v = 5;
  this.group = 0;
  this.id = 0;

  for (var k in options) {
    this[k] = options[k];
  }
};
/**
 * @description 显示事件处理
 */


var Show =
/*#__PURE__*/
function () {
  function Show() {
    _classCallCheck(this, Show);
  }

  _createClass(Show, null, [{
    key: "distribute",

    /**
     * @description 分发事件
     * @param evs 事件列表
     */
    value: function distribute(evs) {
      for (var i = 0, len = evs.length; i < len; i++) {
        Show[evs[i].type] && Show[evs[i].type](evs[i]);
      }
    } //创建军队精灵   

  }, {
    key: "insert",
    value: function insert(ev) {
      if (!fighter_sprite[ev.target.group]) {
        fighter_sprite[ev.target.group] = [];
      }

      fighter_sprite[ev.target.group][ev.target.id] = _scene.default.open("app-ui-fightHero", _global.Global.mainFace.node, null, {
        id: ev.target.id,
        group: ev.target.group,
        left: sitP[ev.target.group][ev.target.id][0],
        top: sitP[ev.target.group][ev.target.id][1]
      });
    }
  }, {
    key: "move",
    value: function move(ev) {
      var army = fighter_sprite[ev.target.group][ev.target.id];
      army.x = ev.target.left;
      army.y = ev.target.top;
    }
  }, {
    key: "effect",
    value: function effect(ev) {
      if (ev.effect == "addscore") {}
    }
  }, {
    key: "remove",
    value: function remove(ev) {
      var shap = fighter_sprite[ev.target.group][ev.target.id];

      _scene.default.remove(shap);

      delete fighter_sprite[ev.target.group][ev.target.id];
    }
  }, {
    key: "over",
    value: function over() {}
  }]);

  return Show;
}();
/**
 * @description  战斗界面组件
 */


var WFight =
/*#__PURE__*/
function (_Widget) {
  _inherits(WFight, _Widget);

  function WFight() {
    _classCallCheck(this, WFight);

    return _possibleConstructorReturn(this, _getPrototypeOf(WFight).apply(this, arguments));
  }

  _createClass(WFight, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WFight.prototype), "setProps", this).call(this, props); // this.cfg.children[1].data.text = DB.data.map.city[0] ;

    }
  }, {
    key: "no",
    value: function no() {}
  }, {
    key: "added",
    value: function added(node) {}
  }]);

  return WFight;
}(_widget.default);
/**
 * @description 伤害飘字
 */


var WfightHp =
/*#__PURE__*/
function (_Widget2) {
  _inherits(WfightHp, _Widget2);

  function WfightHp() {
    _classCallCheck(this, WfightHp);

    return _possibleConstructorReturn(this, _getPrototypeOf(WfightHp).apply(this, arguments));
  }

  _createClass(WfightHp, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WfightHp.prototype), "setProps", this).call(this, props);

      this.cfg.data.text = "-".concat(props.damage);
      this.cfg.data.left = props.left;
      this.cfg.data.top = props.top;
    }
  }, {
    key: "added",
    value: function added(node) {
      damageNode[this.props.index] = this.elements.get("damage");
    }
  }]);

  return WfightHp;
}(_widget.default); //参战军队


var WfightHero =
/*#__PURE__*/
function (_Widget3) {
  _inherits(WfightHero, _Widget3);

  function WfightHero() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, WfightHero);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(WfightHero)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.node = void 0;
    return _this;
  }

  _createClass(WfightHero, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WfightHero.prototype), "setProps", this).call(this, props);

      var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          Cname = ["步", "骑", "弓"],
          group = props.group,
          id = props.id,
          heroId = fighter[group][id][0],
          name = bcfg[heroId]["name"],
          size = [0, 80, 60, 50, 40];

      this.cfg.data.left = props.left;
      this.cfg.data.top = props.top;
      this.cfg.children[2].data.text = "".concat(name);
      this.cfg.children[2].data.style.fill = "".concat(_global.Global.color[bcfg[heroId]["color"]]);
      this.cfg.children[3].data.text = "".concat(armys[group][id].max_hp, " ").concat(Cname[fighter[group][id][4]]);
    }
  }, {
    key: "remove",
    value: function remove() {
      _scene.default.remove(this.node);
    }
  }, {
    key: "added",
    value: function added(node) {
      this.node = node;

      if (!hpNode[this.props.group]) {
        hpNode[this.props.group] = [];
      }

      if (!numberNode[this.props.group]) {
        numberNode[this.props.group] = [];
      }

      hpNode[this.props.group][this.props.id] = this.elements.get("hp");
      numberNode[this.props.group][this.props.id] = this.elements.get("number");
    }
  }]);

  return WfightHero;
}(_widget.default); //战斗结算弹窗


var WfightAccount =
/*#__PURE__*/
function (_Widget4) {
  _inherits(WfightAccount, _Widget4);

  function WfightAccount() {
    var _getPrototypeOf3;

    var _this2;

    _classCallCheck(this, WfightAccount);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _possibleConstructorReturn(this, (_getPrototypeOf3 = _getPrototypeOf(WfightAccount)).call.apply(_getPrototypeOf3, [this].concat(args)));
    _this2.node = void 0;
    return _this2;
  }

  _createClass(WfightAccount, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WfightAccount.prototype), "setProps", this).call(this, props);

      var bcfg = _cfgmrg.default.getOne("app/cfg/city.json@city"),
          bcfg2 = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          bcfg3 = _cfgmrg.default.getOne("app/cfg/city.json@rand"),
          result = [["惨胜", "小胜", "大捷", "完胜"], ["惜败", "小败", "大败", "完败"]],
          result_pd = [0.25, 0.5, 0.75, 1],
          resultId = 0,
          killdie_all = [0, 0],
          after_all = [0, 0];

      this.cfg.data.left = Math.floor((_scene.default.screen.width - this.cfg.data.width) / 2);

      for (var i = 0; i < 2; i++) {
        for (var j = 0; j < fighter[i].length; j++) {
          after_all[i] += fighter[i][j][1];
        }
      } // for(let i=0;i<kill_die[0].length-1;i++){
      //     kill_die[0][4] += kill_die[0][i];
      //     kill_die[1][4] += kill_die[1][i];
      // }
      // if(kill_die[Math.abs(isvic-1)][4]/kill_die[isvic][4] <1){
      //     resultId = 0
      // }else if(kill_die[Math.abs(isvic-1)][4]/kill_die[isvic][4] <2){
      //     resultId = 1
      // }else{
      //     resultId = 2
      // }


      for (var _i3 = 0; _i3 < fighter[0].length; _i3++) {
        this.cfg.children[9 + _i3].data.text = "".concat(bcfg2[fighter[0][_i3][0]]["name"]);
      }

      for (var _i4 = 0; _i4 < fighter[0].length; _i4++) {
        this.cfg.children[14 + _i4].data.text = "".concat(kill_die[0][_i4]);
        killdie_all[0] += kill_die[0][_i4];
      }

      this.cfg.children[17].data.text = "".concat(killdie_all[0]);

      for (var _i5 = 0; _i5 < fighter[0].length; _i5++) {
        this.cfg.children[19 + _i5].data.text = "".concat(kill_die[1][_i5]);
        killdie_all[1] += kill_die[1][_i5];
      }

      this.cfg.children[22].data.text = "".concat(killdie_all[1]); //结算标题总结文字

      for (var _i6 = result[0].length - 1; _i6 >= 0; _i6--) {
        if (after_all[Math.abs(isvic - 1)] / (after_all[Math.abs(isvic - 1)] + killdie_all[isvic]) >= result_pd[_i6]) {
          resultId = _i6;
          break;
        }
      }

      this.cfg.children[7].data.text = "".concat(result[Math.abs(isvic - 1)][resultId]);

      if (!isvic) {
        this.cfg.children[7].data.style.fill = "0xff6347";
      }

      if (isvic) {
        if (cityId < 20000) {
          var st = bcfg[cityId]["reward_dis"].replace("{{city_num}}", _db.default.data.map.city[3]);
          this.cfg.children[23].data.text = "".concat(st.replace(/\\n/, "\n"));
        } else {
          this.cfg.children[23].data.text = "".concat(bcfg3[cityId]["reward_dis"].replace(/\\n/, "\n"));
        }

        if (fa9_army) {
          this.cfg.children[24].data.text = "+".concat(fa9_army, "\u7A7A\u95F2\u58EB\u5175");
        }
      } else {
        //战斗奖励显示
        var _st;

        if (cityId == 19999) {
          if (_db.default.data.map.city[4] == _db.default.data.map.city[0]) {
            _st = "-\u6240\u6709\u5269\u4F59\u57CE\u6C60\n+50\u8D25\u7EE9";
          } else {
            _st = "-".concat(_db.default.data.map.city[4], "\u57CE\u6C60\n+50\u8D25\u7EE9");
          }
        } else {
          _st = "+50败绩";
        }

        this.cfg.children[23].data.text = _st;
        this.cfg.children[23].data.style.fill = "0xff6347";

        if (fa9_army) {
          this.cfg.children[24].data.text = "+".concat(fa9_army, "\u7A7A\u95F2\u58EB\u5175");
        }
      }
    }
  }, {
    key: "remove",
    value: function remove() {
      var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          bcfg2 = _cfgmrg.default.getOne("app/cfg/city.json@city"),
          bcfg3 = _cfgmrg.default.getOne("app/cfg/city.json@rand"),
          arms = ["步兵", "骑兵", "弓兵"],
          fa9_st = "";

      if (fa9_army) {
        fa9_st = ",\u7A7A\u95F2\u58EB\u5175+".concat(fa9_army);
      }

      if (isvic) {
        if (cityId == 19999) {
          if (_db.default.data.map.city[4]) {
            (0, _stage.addNews)("2\u6218\u6597\u80DC\u5229\uFF0C\u51FB\u9000\u4E86\u654C\u4EBA\u7684\u5165\u4FB5\uFF0C\u6536\u590D\u4E86".concat(_db.default.data.map.city[4], "\u57CE\u3002(\u80DC\u7EE9+50").concat(fa9_st, ")"));
          } else {
            (0, _stage.addNews)("2\u6218\u6597\u80DC\u5229\uFF0C\u51FB\u9000\u4E86\u654C\u4EBA\u7684\u5165\u4FB5\u3002(\u80DC\u7EE9+50".concat(fa9_st, ")"));
          }
        }

        if (cityId > 19999) {
          (0, _stage.addNews)("2\u6218\u6597\u80DC\u5229\uFF0C\u626B\u9664\u4E86\u9886\u5730\u5185\u7684".concat(bcfg3[cityId]["name"], "\u3002(\u80DC\u7EE9+50").concat(fa9_st, ")"));
        }

        if (cityId < 19999) {
          (0, _stage.addNews)("2\u6218\u6597\u80DC\u5229\uFF0C\u5360\u9886\u4E86".concat(bcfg2[cityId]["name"], "\u3002(\u80DC\u7EE9+100,\u5EFA\u7B51\u4E0A\u9650+").concat(_db.default.data.map.city[3]).concat(fa9_st, ")"));

          if (_db.default.data.map.city[0] > 178) {
            _scene.default.open("app-ui-result", _scene.default.root, null, {
              id: 3
            });
          }
        }
      } else {
        if (cityId == 19999) {
          if (_db.default.data.date.day[0] == 0) {
            _scene.default.open("app-ui-result", _scene.default.root, null, {
              id: 0
            });
          } else {
            (0, _stage.addNews)("6\u6218\u6597\u5931\u8D25\uFF0C\u5931\u53BB\u4E86\u8FB9\u5883".concat(_db.default.data.map.city[4], "\u57CE\u3002(\u8D25\u7EE9+50").concat(fa9_st, ")"));
          }
        }

        if (cityId > 19999) {
          (0, _stage.addNews)("6\u6218\u6597\u5931\u8D25\u3002(\u8D25\u7EE9+50".concat(fa9_st, ")"));
        }

        if (cityId < 19999) {
          (0, _stage.addNews)("6\u6218\u6597\u5931\u8D25\u3002(\u8D25\u7EE9+50".concat(fa9_st, ")"));
        }

        if (cityId == 19999) {
          var name = "军备官";

          if (_db.default.data.hero.own[0]) {
            name = bcfg[_db.default.data.hero.own[0][0]]["name"];
          }

          (0, _stage.addNews)("".concat(name, "\uFF1A\u6B64\u8BDA\u5371\u6025\u5B58\u4EA1\u4E4B\u79CB\u4E5F\u3002\u671B\u4E3B\u516C\u5C3D\u5FEB\u7EC4\u7EC7\u53CD\u653B\uFF0C\u4E0D\u53EF\u61C8\u6020\uFF01"));
        }
      } //将领受伤


      if (hero_news[0]) {
        for (var i = 0; i < hero_news[0].length; i++) {
          (0, _stage.addNews)("6".concat(bcfg[hero_news[0][i]]["name"], "\u5728\u6218\u6597\u4E2D\u8D1F\u4F24\uFF0C\u9700\u8981\u4F11\u517B\u4E00\u6BB5\u65F6\u95F4\u3002"));
        }
      }

      if (hero_news[1]) {
        for (var _i7 = 0; _i7 < hero_news[1].length; _i7++) {
          (0, _stage.addNews)("2\u4E45\u5386\u6C99\u573A\uFF0C".concat(bcfg[hero_news[1][_i7]]["name"], "\u7684").concat(arms[bcfg[hero_news[1][_i7]]["arms"]], "\u80FD\u529B+1"));
        }
      }

      _scene.default.remove(_global.Global.mainFace.node);

      damageSprite = []; //游戏结束，不需要回去

      if (_db.default.data.date.day[0] > 0) {
        _appEmitter.AppEmitter.emit("stageStart");

        _appEmitter.AppEmitter.emit("".concat(faceName[lastFace]));
      }

      Fight.pause = 1;

      _music.default.play("audio/season".concat(Math.floor(_db.default.data.date.day[0] / 100) % 4, ".mp3"), true);
    }
  }, {
    key: "added",
    value: function added(node) {
      this.node = node;
    }
  }]);

  return WfightAccount;
}(_widget.default);
/**
 * @description 领取奖励
 */


var reward = function reward() {
  var index = [],
      fa4 = 0;

  for (var i = 0; i < fighter[0].length; i++) {
    index.push(fighter[0][i][3]);
  }

  for (var _i8 = 0; _i8 < _db.default.data.fore.fa.length; _i8++) {
    if (_db.default.data.fore.fa[_i8] == 4) {
      fa4 = 1;
    }
  } //发放战斗奖励


  _connect.default.request({
    type: "app/fight@fightAccount",
    arg: {
      isvic: isvic,
      cityId: cityId,
      heroIndex: index,
      fa4: fa4
    }
  }, function (data) {
    if (data.err) {
      return console.log(data.err.reson);
    } //游戏失败


    if (cityId == 19999 && !isvic) {
      if (_db.default.data.map.city[4] > 0) {
        _connect.default.request({
          type: "app/circle@putin",
          arg: []
        }, function (data) {
          if (data.err) {
            return console.log(data.err.reson);
          } else {
            _db.default.data.circle = data.ok[0];
            _db.default.data.date.day[0] = data.ok[1];
          }
        });
      }
    }

    if (cityId == 19999) {
      _db.default.data.map.attack[0] = 0;
      _db.default.data.map.city[4] = data.ok[5];
    } //游戏通关


    if (cityId < 19999 && isvic && _db.default.data.map.city[0] > 177) {
      _connect.default.request({
        type: "app/circle@putin",
        arg: []
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        } else {
          _db.default.data.circle = data.ok[0];
          _db.default.data.date.day[0] = data.ok[1];
        }
      });
    }

    _db.default.data.res.fail[1] = data.ok[0];
    _db.default.data.res.win[1] = data.ok[1];

    if (data.ok[2] != "no") {
      var bcfg = _cfgmrg.default.getOne("app/cfg/city.json@city");

      if (cityId > 19999 && cityId < 30000) {
        bcfg = _cfgmrg.default.getOne("app/cfg/city.json@rand");
      }

      var effect = bcfg[cityId]["effect_type"],
          effect_num = bcfg[cityId]["effect_number"];

      for (var _i9 = 0; _i9 < effect_num.length; _i9++) {
        _db.default.data[effect[_i9][0]][effect[_i9][1]][effect[_i9][2]] = data.ok[2][_i9];
      }
    } //将领数值


    if (data.ok[3]) {
      for (var _i10 = 0; _i10 < index.length; _i10++) {
        var id = _db.default.data.hero.own[index[_i10]][0];

        if (Math.floor(data.ok[3][index[_i10]][2]) > Math.floor(_db.default.data.hero.own[index[_i10]][2])) {
          hero_news[1].push(id);
        }

        if (data.ok[3][index[_i10]][1] == 0) {
          hero_news[0].push(id);
        }
      }

      _db.default.data.hero.own = data.ok[3];
    }

    _db.default.data.hero.MaxHero[2] = data.ok[4];
    _db.default.data.fore.fa = (0, _global.fature)();

    if (_db.default.data.army.fature[0]) {
      _appEmitter.AppEmitter.emit("updateEffect");
    }
  });
};
/**
 * @description 打开战斗界面
 */


var open = function open() {
  _global.Global.mainFace.node = _scene.default.open("app-ui-fight", _scene.default.root);
  _global.Global.mainFace.id = 5;
  Fight.nextFrame = Date.now() + Fight.time;

  _music.default.play("audio/fight.mp3", true);

  _appEmitter.AppEmitter.emit("stagePause");

  hero_news = [[], []];
  sitP = [];
  attP = [];
  Fight.events = []; //判断是否有群英荟萃效果

  isfa12 = 0;

  for (var i = 0; i < _db.default.data.fore.fa.length; i++) {
    if (_db.default.data.fore.fa[i] == 12) {
      isfa12 = 1;
    }
  } //显示军队


  for (var _i11 = 0; _i11 < 2; _i11++) {
    for (var j = 0; j < fighter[_i11].length; j++) {
      if (!sitP[_i11]) {
        sitP[_i11] = [];
      }

      if (!attP[_i11]) {
        attP[_i11] = [];
      }

      if (!sitP[_i11][j]) {
        sitP[_i11][j] = [];
      }

      if (!attP[_i11][j]) {
        attP[_i11][j] = [];
      }

      sitP[_i11][j].push((_scene.default.screen.width - 200 * fighter[_i11].length) / (fighter[_i11].length + 1) * (j + 1) + 200 * j, 634 - 534 * _i11);

      attP[_i11][j].push(sitP[_i11][j][0], sitP[_i11][j][1] + 200 * (_i11 ? 1 : -1));

      if (!armys[_i11]) {
        armys[_i11] = [];
      }

      armys[_i11][j] = new Army({
        left: sitP[_i11][j][0],
        top: sitP[_i11][j][1],
        hp: fighter[_i11][j][1],
        max_hp: fighter[_i11][j][1],
        group: _i11,
        id: j
      });
      Fight.events.push({
        type: "insert",
        target: armys[_i11][j]
      });
    }
  }

  var fa = [];

  if (_db.default.data.army.fature[0]) {
    fa = _db.default.data.fore.fa;
  }

  _connect.default.request({
    type: "app/fight@fight",
    arg: [fighter, enemyType, fa]
  }, function (data) {
    if (data.err) {
      return console.log(data.err.reson);
    }

    isvic = data.ok[0];
    fight_show = data.ok[1];
    _db.default.data.hero.own = data.ok[2];

    if (enemyType > -1) {
      _db.default.data.map.guard = data.ok[3];
    } else {
      _db.default.data.hero.enemy = data.ok[3];
    }

    _db.default.data.army.total[0] = data.ok[4];
    kill_die = data.ok[5];
    _db.default.data.army.cur[0] = data.ok[6];
    fa9_army = data.ok[7];
    Fight.pause = 0;
    state = "start";
    reward();
  });
};
/****************** 立即执行 ******************/
//注册组件


_widget.default.registW("app-ui-fightAccount", WfightAccount);

_widget.default.registW("app-ui-fight", WFight);

_widget.default.registW("app-ui-fightHero", WfightHero);

_widget.default.registW("app-ui-fightHp", WfightHp); //注册页面打开事件


_appEmitter.AppEmitter.add("intoFight", function (node) {
  lastFace = _global.Global.mainFace.id;
  fighter = node.fighter;
  enemyType = node.enemyType;
  cityId = node.city;
  open();
});

_frame.default.add(function () {
  if (!Fight.pause) {
    Show.distribute(Fight.loop());
  }
});
})