define("app/map",function(require,exports,module){
"use strict";

var _scene = _interopRequireDefault(require("libs/ni/scene"));

var _db = _interopRequireDefault(require("libs/ni/db"));

var _widget = _interopRequireDefault(require("libs/ni/widget"));

var _cfgmrg = _interopRequireDefault(require("libs/ni/cfgmrg"));

var _appEmitter = require("app/appEmitter");

var _connect = _interopRequireDefault(require("libs/ni/connect"));

var _global = require("app/global");

var _stage = require("app/stage");

var _music = _interopRequireDefault(require("libs/ni/music"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/****************** 导出 ******************/

/****************** 本地 ******************/
var cityNumberNode,
    // 占领城市节点
mul = 3; //武将兵种数值系数

var Map =
/*#__PURE__*/
function () {
  function Map() {
    _classCallCheck(this, Map);
  }

  _createClass(Map, null, [{
    key: "initDB",
    //据点精灵
    //敌军描述节点
    //tips描述节点
    value: function initDB() {
      //初始化敌军数据库guard: [[[据点ID],[将领id,人数],[将领id,人数]],..]
      //city:[占领城市数量，，所有建筑数量，每个城市增加的建筑,被占领城市数量,初始建筑数量上限]
      _db.default.init("map", {
        date: [1],
        city: [1, 10000, 0, 15, 0, 100],
        attack: [0],
        guard: []
      });
    } //更新据点

  }, {
    key: "updateGuard",
    value: function updateGuard() {
      var time = [15, 50, 120];
      var newDate = _db.default.data.date.day[0] + Math.ceil(time[_db.default.data.map.guard.length] * ((700 + (0, _global.rand)(600)) / 1000)); //更新下一次时间

      if ((newDate < _db.default.data.map.date[0] || _db.default.data.map.date[0] <= _db.default.data.date.day[0]) && _db.default.data.map.guard.length < 3) {
        _connect.default.request({
          type: "app/map@date_update",
          arg: newDate
        }, function (data) {
          if (data.err) {
            return console.log(data.err.reson);
          }

          _db.default.data.map.date[0] = data.ok[0];
        });
      } //更新据点精灵


      if (_global.Global.mainFace.id == 4) {
        for (var i = 0; i < _db.default.data.map.guard.length; i++) {
          if (_db.default.data.map.guard[i][0]) {
            Map.city_sprite[i] = _scene.default.open("app-ui-city", _global.Global.mainFace.node, null, {
              id: _db.default.data.map.guard[i][0],
              index: i
            });
          }
        }

        if (!_db.default.data.map.guard[0]) {
          Map.tipsNode.text = "请等待斥候探查情报";
        } else {
          Map.tipsNode.text = "";
        }
      }
    }
  }, {
    key: "updateCity",
    value: function updateCity() {
      if (_global.Global.mainFace.id == 4) {
        var st = "";

        if (_db.default.data.map.city[4]) {
          st = "(".concat(-_db.default.data.map.city[4], ")");
          cityNumberNode.style.fill = _global.Global.color[6];
        }

        cityNumberNode.text = "".concat(_db.default.data.map.city[0]).concat(st, "/179");
      }
    }
  }]);

  return Map;
}();
/**
 * @description  地图界面组件
 */


Map.city_sprite = [];
Map.armyNode = [];
Map.tipsNode = void 0;

var WMap =
/*#__PURE__*/
function (_Widget) {
  _inherits(WMap, _Widget);

  function WMap() {
    _classCallCheck(this, WMap);

    return _possibleConstructorReturn(this, _getPrototypeOf(WMap).apply(this, arguments));
  }

  _createClass(WMap, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WMap.prototype), "setProps", this).call(this, props);

      var st = "";

      if (_db.default.data.map.city[4]) {
        st = "(".concat(-_db.default.data.map.city[4], ")");
        this.cfg.children[1].data.style.fill = _global.Global.color[6];
      }

      this.cfg.children[1].data.text = "".concat(_db.default.data.map.city[0]).concat(st, "/179");

      if (!_db.default.data.map.guard[0]) {
        this.cfg.children[5].data.text = "请等待斥候探查情报";
      }

      this.cfg.children[4].data.width = 325 + _scene.default.screen.width - 750;
    }
  }, {
    key: "added",
    value: function added(node) {
      cityNumberNode = this.elements.get("city_number");
      Map.tipsNode = this.elements.get("tips");
    }
  }]);

  return WMap;
}(_widget.default); //据点城市弹窗


var WCity =
/*#__PURE__*/
function (_Widget2) {
  _inherits(WCity, _Widget2);

  function WCity() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, WCity);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(WCity)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.node = void 0;
    _this.backNode = void 0;
    return _this;
  }

  _createClass(WCity, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WCity.prototype), "setProps", this).call(this, props);

      var bcfg,
          bcfg2 = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          Cname = ["步", "骑", "弓"],
          id = props.id,
          army = _db.default.data.map.guard[props.index],
          str2 = "",
          color,
          time = 0; //判断城市还是随机据点


      if (id < 20000) {
        bcfg = _cfgmrg.default.getOne("app/cfg/city.json@city");
      } else {
        bcfg = _cfgmrg.default.getOne("app/cfg/city.json@rand");
      } //判断时间点


      if (bcfg[id]["time"] && bcfg[id]["time"].length) {
        for (var i = bcfg[id]["time"].length; i >= 0; i--) {
          if (army[2] && army[2][0] == bcfg[id]["hero"][i][1]) {
            time = i;
            break;
          }
        }
      }

      str2 = bcfg[id]["reward_dis"];
      str2 = str2.replace("{{city_num}}", _db.default.data.map.city[3]);
      this.cfg.children[1].data.text = "".concat(bcfg[id]["name"]);

      if (id < 20000) {
        this.cfg.children[2].data.text = "\uFF08".concat(bcfg[id]["belong"][time], "\uFF09");
      } else {
        this.cfg.children[2].data.text = "\uFF08".concat(bcfg[id]["belong"], "\uFF09");
      } //驻守军队


      for (var _i = 1; _i < army.length; _i++) {
        this.cfg.children[2 + _i].data.text = "".concat(bcfg2[army[_i][0]]["name"], "(").concat(army[_i][1]).concat(Cname[bcfg2[army[_i][0]]["arms"]], ")");
        color = bcfg2[army[_i][0]]["color"];
        this.cfg.children[2 + _i].data.style.fill = _global.Global.color[color];
      }

      this.cfg.children[6].data.text = "".concat(str2.replace(/\\n/, "\n"));
      this.cfg.data.left = (_scene.default.screen.width - 660) / 4 * (props.index + 1) + 220 * props.index;
      this.cfg.on = {
        "tap": {
          "func": "choose",
          "arg": [id]
        }
      };
    }
  }, {
    key: "choose",
    value: function choose(id) {
      _music.default.play("audio/but.mp3");

      if (_db.default.data.army.cur[0] < _db.default.data.army.total[0]) {
        _appEmitter.AppEmitter.emit("stagePause");

        this.backNode = _scene.default.open("app-ui-back", _scene.default.root);

        _scene.default.open("app-ui-fightWindow", this.backNode, null, {
          id: this.props.id,
          index: this.props.index,
          backNode: this.backNode
        });
      } else {
        _appEmitter.AppEmitter.emit("message", "\u65E0\u53EF\u51FA\u6218\u7684\u519B\u961F\uFF01");
      }
    }
  }, {
    key: "remove",
    value: function remove() {
      _scene.default.remove(this.node);
    }
  }, {
    key: "added",
    value: function added(node) {
      this.node = node;
      Map.armyNode[this.props.index] = this.elements.get("army");
    }
  }]);

  return WCity;
}(_widget.default); //战斗弹窗


var WfightWindow =
/*#__PURE__*/
function (_Widget3) {
  _inherits(WfightWindow, _Widget3);

  function WfightWindow() {
    var _getPrototypeOf3;

    var _this2;

    _classCallCheck(this, WfightWindow);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _possibleConstructorReturn(this, (_getPrototypeOf3 = _getPrototypeOf(WfightWindow)).call.apply(_getPrototypeOf3, [this].concat(args)));
    _this2.node = void 0;
    return _this2;
  }

  _createClass(WfightWindow, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WfightWindow.prototype), "setProps", this).call(this, props);

      var bcfg,
          bcfg2 = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          Cname = ["步", "骑", "弓"],
          id = props.id,
          army = [],
          str1 = "",
          str2 = "",
          max = 0,
          name;

      this.cfg.data.left = Math.floor((_scene.default.screen.width - this.cfg.data.width) / 2); //暂停时间    

      _appEmitter.AppEmitter.emit("stagePause"); //判断是进攻还是被入侵


      if (props.index >= 0) {
        army = _db.default.data.map.guard[props.index];
      } else {
        army = JSON.parse(JSON.stringify(_db.default.data.hero.enemy));
        army.unshift([]);
      } //判断城市还是随机据点


      if (id < 20000) {
        bcfg = _cfgmrg.default.getOne("app/cfg/city.json@city");
      } else {
        bcfg = _cfgmrg.default.getOne("app/cfg/city.json@rand");
      }

      if (props.name) {
        name = props.name;
      } else {
        name = bcfg[id]["name"];
      } //我军上阵


      for (var i = 0; i < _db.default.data.hero.own.length; i++) {
        if (_db.default.data.hero.own[i][1] > 0) {
          str1 = "".concat(str1, "\n").concat(bcfg2[_db.default.data.hero.own[i][0]]["name"], "(").concat(_db.default.data.hero.own[i][1]).concat(Cname[bcfg2[_db.default.data.hero.own[i][0]]["arms"]], ")");
          max += 1;

          if (max == _db.default.data.hero.MaxHero[0]) {
            break;
          }
        }
      } //敌军上阵


      for (var _i2 = 1; _i2 < army.length; _i2++) {
        str2 = "".concat(str2, "\n").concat(bcfg2[army[_i2][0]]["name"], "(").concat(army[_i2][1]).concat(Cname[bcfg2[army[_i2][0]]["arms"]], ")");
      } //迎战界面


      if (props.index == -2) {
        this.cfg.children[5].props.text = "迎战";
        this.cfg.children[5].props.left = 450;
        this.cfg.children[6].props.left = 150;
        this.cfg.children[7].data.alpha = 1;
      }

      this.cfg.children[1].data.text = "".concat(name);
      this.cfg.children[2].children[0].data.text = "\u6211\u519B".concat(str1);
      this.cfg.children[3].children[0].data.text = "\u654C\u519B".concat(str2);
    }
  }, {
    key: "fight",
    value: function fight() {
      //判断是否有军队
      if (_db.default.data.army.cur[0] < _db.default.data.army.total[0]) {
        var own = [],
            bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
            bcfg2 = _cfgmrg.default.getOne("app/cfg/city.json@city"),
            bcfg4 = _cfgmrg.default.getOne("app/cfg/city.json@army"),
            max = 0,
            army = [];

        if (this.props.index >= 0) {
          army = _db.default.data.map.guard[this.props.index];
        } else {
          army = JSON.parse(JSON.stringify(_db.default.data.hero.enemy));
          army.unshift([]);
        }

        for (var i = 0; i < _db.default.data.hero.own.length; i++) {
          if (_db.default.data.hero.own[i][1] > 0) {
            if (!own[max]) {
              own[max] = [];
            }

            own[max][0] = _db.default.data.hero.own[i][0];
            own[max][1] = _db.default.data.hero.own[i][1];
            own[max][4] = bcfg[own[max][0]]["arms"];
            own[max][2] = 1 + Math.floor(bcfg[own[max][0]]["number"] + _db.default.data.hero.own[i][2] + _db.default.data.hero.add[own[max][4] + 1]) * mul / 100;
            own[max][3] = _db.default.data.hero.own[i][3];
            max += 1;

            if (max == _db.default.data.hero.MaxHero[0]) {
              break;
            }
          }
        } //四种战斗建筑选最大的来调整


        var add_x = 0;

        for (var _i3 = 0; _i3 < 4; _i3++) {
          if (_db.default.data.hero.add[_i3] > add_x) {
            add_x = _db.default.data.hero.add[_i3];
          }
        }

        var enemy = [];

        for (var _i4 = 0; _i4 < army.length - 1; _i4++) {
          if (!enemy[_i4]) {
            enemy[_i4] = [];
          }

          enemy[_i4][0] = army[_i4 + 1][0];
          enemy[_i4][1] = army[_i4 + 1][1]; //判断是否是城市

          if (this.props.id < 19999) {
            enemy[_i4][2] = 1 + (bcfg[enemy[_i4][0]]["number"] / 100 + bcfg2[this.props.id]["attribute"]) * mul;
            var x = 10;

            if (_db.default.data.map.city[0] > 45) {
              x = 5;
            }

            if (_db.default.data.map.city[0] > 50) {
              x = 3.5;
            }

            if (_db.default.data.map.city[0] > 65) {
              x = 2.2;
            }

            if (_db.default.data.map.city[0] > 80) {
              x = 1.7;
            }

            if (_db.default.data.map.city[0] > 100) {
              x = 1.5;
            }

            if (_db.default.data.map.city[0] > 120) {
              x = 1.35;
            }

            if (_db.default.data.map.city[0] > 140) {
              x = 1.2;
            }

            if (_db.default.data.map.city[0] > 160) {
              x = 1.1;
            }

            enemy[_i4][2] += Math.floor(add_x / x) / 100 * mul;
          } else {
            enemy[_i4][2] = 1 + (bcfg[enemy[_i4][0]]["number"] / 100 + bcfg4[Math.ceil(_db.default.data.date.day[0] / 400)]["attribute"]) * mul;
          } //动态调整


          if (this.props.id == 19999) {
            var _x = 4.2;

            if (_db.default.data.date.day[0] > 8000) {
              _x = 3.4;
            }

            if (_db.default.data.date.day[0] > 10600) {
              _x = 3;
            }

            if (_db.default.data.date.day[0] > 11600) {
              _x = 2.6;
            }

            if (_db.default.data.date.day[0] > 15200) {
              _x = 2.2;
            }

            if (_db.default.data.date.day[0] > 19200) {
              _x = 1.8;
            }

            if (_db.default.data.date.day[0] > 23200) {
              _x = 1.6;
            }

            if (_db.default.data.date.day[0] > 27200) {
              _x = 1.4;
            }

            if (_db.default.data.date.day[0] > 32200) {
              _x = 1.25;
            }

            if (_db.default.data.date.day[0] > 37200) {
              _x = 1.1;
            }

            if (_db.default.data.date.day[0] > 40200) {
              _x = 0.8;
            }

            enemy[_i4][2] += Math.floor(add_x / _x) / 100 * mul;
          } else if (this.props.id > 19999) {
            enemy[_i4][2] -= Math.floor(add_x / 4) / 100 * mul;

            if (enemy[_i4][2] < 1 + 0.25 * mul) {
              enemy[_i4][2] = 1 + 0.25 * mul;
            }
          } //根据战阵数调整难度


          if (_db.default.data.army.fature[0] && _db.default.data.date.day[0] > 8800) {
            if (_db.default.data.fore.fa.length == 0) {
              enemy[_i4][2] = enemy[_i4][2] * 1.3;
            } else if (_db.default.data.fore.fa.length == 1) {
              enemy[_i4][2] = enemy[_i4][2] * 1.1;
            }
          }

          enemy[_i4][3] = _i4;
          enemy[_i4][4] = bcfg[enemy[_i4][0]]["arms"];
        }

        _scene.default.remove(_global.Global.mainFace.node);

        _appEmitter.AppEmitter.emit("intoFight", {
          fighter: [own, enemy],
          city: this.props.id,
          enemyType: this.props.index
        });

        this.remove();
      } else {
        _appEmitter.AppEmitter.emit("message", "\u65E0\u53EF\u51FA\u6218\u7684\u519B\u961F\uFF01");
      }
    }
  }, {
    key: "remove",
    value: function remove() {
      _scene.default.remove(this.node);
    } //投降

  }, {
    key: "lose",
    value: function lose() {
      var _this3 = this;

      _connect.default.request({
        type: "app/fight@lose",
        arg: []
      }, function (data) {
        if (data.err == 1) {
          _connect.default.request({
            type: "app/circle@putin",
            arg: []
          }, function (data) {
            if (data.err) {
              return console.log(data.err.reson);
            } else {
              _db.default.data.circle = data.ok[0];
              _db.default.data.date.day[0] = data.ok[1];
            }
          });

          _scene.default.open("app-ui-result", _scene.default.root, null, {
            id: 0
          });
        } else {
          _db.default.data.map.attack[0] = 0;
          _db.default.data.map.city[4] = data.ok[0];
          _db.default.data.res.fail[1] = data.ok[1];
          _db.default.data.res.win[1] = data.ok[2];

          _appEmitter.AppEmitter.emit("stageStart");

          (0, _stage.addNews)("6\u5272\u8BA9\u8FB9\u5883".concat(_db.default.data.map.city[4], "\u57CE\u3002(\u8D25\u7EE9+50)"));

          var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
              name = _db.default.data.hero.own[0] ? bcfg[_db.default.data.hero.own[0][0]]["name"] : "军备官";

          if (_db.default.data.hero.own[0]) {
            (0, _stage.addNews)("".concat(name, "\uFF1A\u6B64\u8BDA\u5371\u6025\u5B58\u4EA1\u4E4B\u79CB\u4E5F\u3002\u671B\u4E3B\u516C\u5C3D\u5FEB\u7EC4\u7EC7\u53CD\u653B\uFF0C\u4E0D\u53EF\u61C8\u6020\uFF01"));
          }

          _this3.remove();
        }
      });
    }
  }, {
    key: "added",
    value: function added(node) {
      this.node = this.props.backNode;
    }
  }]);

  return WfightWindow;
}(_widget.default);
/**
 * @description 打开地图界面
 */


var open = function open() {
  _global.Global.mainFace.node = _scene.default.open("app-ui-map", _scene.default.root);
  _global.Global.mainFace.id = 4; //显示据点按钮

  for (var i = 0; i < _db.default.data.map.guard.length; i++) {
    if (_db.default.data.map.guard[i][0]) {
      Map.city_sprite[i] = _scene.default.open("app-ui-city", _global.Global.mainFace.node, null, {
        id: _db.default.data.map.guard[i][0],
        index: i
      });
    }
  }
};
/****************** 立即执行 ******************/
//注册组件


_widget.default.registW("app-ui-map", WMap);

_widget.default.registW("app-ui-fightWindow", WfightWindow);

_widget.default.registW("app-ui-city", WCity); //注册页面打开事件


_appEmitter.AppEmitter.add("intoMap", function (node) {
  open();
}); //监听据点


_db.default.emitter.add("map.guard", function () {
  Map.updateGuard();
}); //监听占领城市


_db.default.emitter.add("map.city.0", function () {
  Map.updateCity();
});

_db.default.emitter.add("map.city.4", function () {
  Map.updateCity();
}); //初始化数据库


_appEmitter.AppEmitter.add("initDB", function (node) {
  Map.initDB();
});
})