define("app/net",function(require,exports,module){
"use strict";

var _connect = _interopRequireDefault(require("libs/ni/connect"));

var _cfgmrg = _interopRequireDefault(require("libs/ni/cfgmrg"));

var _appEmitter = require("app/appEmitter");

var _global = require("app/global");

var _util = _interopRequireDefault(require("libs/ni/util"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/****************** 导入 ******************/

/**
 * @description 模拟后台测试
 */
//存储
var work_name = ["total", "food", "wood", "sci", "gold"],
    res_name = ["food", "wood", "sci", "gold", "win", "fail"],
    season = [0.5, 0, 0, -0.75],
    five_res = [[0, 0, 0, 0.5], [0, 0.5, 0, 0], [0, 0, 0.5, 0], [-0.25, 0, 0, 0], [0.5, 0, 0, 0]],
    bd_city = 0,
    bd_rand = 0;

var saveDb = function saveDb(key, data) {
  localStorage.setItem(key, JSON.stringify(data));
};

var DB;

var initScience = function initScience() {
  var bcfg = _cfgmrg.default.getOne("app/cfg/science.json@science");

  for (var k in bcfg) {
    DB.science.push([0, 0]);
  }
};

var initBuild = function initBuild() {
  var bcfg = _cfgmrg.default.getOne("app/cfg/build.json@build");

  for (var k in bcfg) {
    DB.build.push([0, 0]);
  }
};

var initHero = function initHero() {
  var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero");

  for (var i in bcfg) {
    if (parseInt(i) < 1900) {
      DB.hero.left[bcfg[i]["color"]].push(i);
    }
  }
};

var initDB = function initDB() {
  var cir;

  if (DB && DB.circle && DB.circle.city && DB.circle.city[0]) {
    cir = JSON.parse(JSON.stringify(DB.circle));
  }

  DB = undefined;
  DB = {
    res: {
      food: [1, 0, 5000, 0, 0, 0, 0],
      wood: [0, 0, 600, 0, 0, 0, 0],
      sci: [0, 0, 800, 0, 0, 0, 0],
      gold: [0, 0, 500, 0, 0, 0, 0],
      win: [0, 0, 100, 0, 0, 1, 0],
      fail: [0, 0, 100, 0, 0, 1, 0]
    },
    build: [],
    date: {
      unlock: [0, 0],
      day: [0],
      warning: [0, 0]
    },
    people: {
      total: [0, 0],
      food: [0, 0, 8, 0],
      wood: [0, 0, 1, 0],
      sci: [0, 0, 1, 0],
      gold: [0, 0, 1, 0],
      win: [0, 0, 0.25, 0],
      fail: [0, 0, 0.25, 0]
    },
    face: {
      unlock: [0, 0, 1, 0, 0]
    },
    science: [[1, 0]],
    hero: {
      MaxHero: [1, 1, 0],
      own: [],
      enemy: [],
      left: [[], [], [], [], [], []],
      choose: [1212, 1208, 1200],
      add: [0, 0, 0, 0]
    },
    hotel: {
      date: [0],
      price: [10]
    },
    shop: {
      date: [0],
      price: [0.125, 1, 1, 8, 1, 1],
      number: [200]
    },
    army: {
      cur: [0],
      total: [0],
      price: [250, 5, 1],
      max: [1000],
      fature: [0]
    },
    map: {
      date: [1],
      city: [1, 10000, 0, 15, 0, 100],
      attack: [0],
      guard: []
    },
    event: {
      next: [2001],
      date: [0]
    },
    circle: {
      coin: [0],
      own: [],
      city: [],
      times: [0],
      temp: [[0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0, 0, 0, 0, 0, 0]]
    },
    news: [[], []]
  };

  if (cir) {
    DB.circle = cir;
  }

  initScience();
  initBuild();
  initHero();
}; //继续游戏读取数据


var read_all = function read_all(param, callback) {
  var r = "",
      rs;

  for (var k in DB) {
    rs = localStorage[k];

    if (rs) {
      DB[k] = JSON.parse(rs);
    } else {
      console.log(k);
    }

    r = "".concat(r).concat(r ? "," : "", "\"").concat(k, "\":").concat(rs || JSON.stringify(DB[k]));
  }

  callback({
    ok: "{".concat(r, "}")
  });
}; //储存所有数据


var save_all = function save_all(param, callback) {
  for (var k in DB) {
    saveDb("".concat(k), DB["".concat(k)]);
  }

  callback({
    ok: 1
  });
};

_connect.default.setTest("app/all@read", read_all);

_connect.default.setTest("app/all@save", save_all);
/****************** circle ******************/


var putin = function putin(param, callback) {
  //    DB.circle.year[0] = Math.max(Math.ceil(DB.date.day[0]/400),DB.circle.year[0])
  DB.circle.times[0] += 1;
  DB.circle.city.push([DB.map.city[0], DB.circle.times[0], DB.date.day[0]]); //纪录排序

  if (DB.circle.city.length > 1) {
    for (var i = 0; i < DB.circle.city.length; i++) {
      for (var j = i + 1; j < DB.circle.city.length; j++) {
        if (DB.circle.city[i][0] < DB.circle.city[j][0] || DB.circle.city[i][2] && DB.circle.city[j][2] && DB.circle.city[i][0] == DB.circle.city[j][0] && DB.circle.city[i][2] > DB.circle.city[j][2]) {
          var t = DB.circle.city[i];
          DB.circle.city[i] = DB.circle.city[j];
          DB.circle.city[j] = t;
        }
      }
    }
  }

  if (DB.circle.city.length > 10) {
    DB.circle.city.splice(-1, 1);
  }

  DB.circle.coin[0] = DB.circle.city[0][0];
  DB.circle.own = JSON.parse(JSON.stringify(DB.hero.own)); //时间归零，游戏结束

  DB.date.day[0] = 0;
  saveDb("date", DB.date);
  saveDb("circle", DB.circle);
  callback({
    ok: [JSON.parse(JSON.stringify(DB.circle)), DB.date.day[0]]
  });
}; //轮回商店兑换物存入初始数据库


var putout = function putout(param, callback) {
  //    DB.circle.year[0] = Math.ceil(DB.date.day[0]/400) >DB.circle.year[0]?Math.ceil(DB.date.day[0]/400):DB.circle.year[0]
  DB.circle.coin[0] = DB.circle.city[0][0];
  var res = [2000, 200, 200, 200],
      shopBuild = [1000, 1005, 1008, 1007],
      //返回的效果结果
  effect_end = [],
      build_number = 0;

  for (var i = 0; i < 4; i++) {
    if (DB.circle.temp[0][i]) {
      DB.res[work_name[i + 1]][0] = 1;
      DB.res[work_name[i + 1]][1] = DB.circle.temp[0][i] * res[i];
    }
  }

  for (var _i = 0; _i < shopBuild.length; _i++) {
    if (!effect_end[_i]) {
      effect_end[_i] = [];
    }

    if (DB.circle.temp[1][_i]) {
      DB.build[shopBuild[_i] - 1000][0] = 1;
      DB.build[shopBuild[_i] - 1000][1] = DB.circle.temp[1][_i];
      build_number += DB.circle.temp[1][_i]; //如果解锁了果园，把山路也解锁了

      if (shopBuild[_i] == 1000) {
        DB.build[14][0] = 1;
      }

      if (shopBuild[_i] == 1007) {
        DB.face.unlock[3] = 1;
      }

      var bcfg = _cfgmrg.default.getOne("app/cfg/build.json@build"),
          _id = shopBuild[_i],
          effect = bcfg[_id]["effect_type"],
          effect_num = bcfg[_id]["effect_number"]; //判断数据表


      for (var j = 0; j < effect_num.length; j++) {
        //如果是仓库，特殊处理
        if (_id == 1005) {
          var all = 0;

          for (var k = 1; k <= DB.circle.temp[1][_i]; k++) {
            var n = effect_num[j] * k;

            if (k > 65) {
              n = n * 10;
            } else if (k > 55) {
              n = n * 5;
            } else if (k > 45) {
              n = n * 3;
            } else if (k > 35) {
              n = n * 2;
            } else if (k > 25) {
              n = n * 1.5;
            }

            all += n;
          }

          DB[effect[j][0]][effect[j][1]][effect[j][2]] += all;
        } else {
          DB[effect[j][0]][effect[j][1]][effect[j][2]] += effect_num[j] * DB.circle.temp[1][_i];

          if (shopBuild[_i] == 1007 && DB.circle.temp[1][_i] > 8) {
            DB[effect[j][0]][effect[j][1]][effect[j][2]] = 9;
          }
        }

        effect_end[_i].push(DB[effect[j][0]][effect[j][1]][effect[j][2]]);
      }
    }
  }

  DB.map.city[2] = build_number;
  var id = 0;

  for (var _i2 = 0; _i2 < DB.circle.own.length; _i2++) {
    var _bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
        v = void 0;

    if (DB.circle.temp[2][_i2]) {
      DB.circle.own[_i2][1] = 0;
      DB.circle.own[_i2][3] = id;
      DB.circle.own[_i2][4] = 0;
      DB.hero.own.push(DB.circle.own[_i2]);
      id += 1;
      v = _bcfg[DB.circle.own[_i2][0]]["color"];
      DB.hero.left[v].splice(DB.hero.left[v].indexOf("".concat(DB.circle.own[_i2][0])), 1);
    }
  }

  if (DB.hero.own[0] && DB.hero.own[0][0]) {
    DB.face.unlock[3] = 1;
  }

  DB.circle.temp = [[0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]];
  saveDb("res", DB.res);
  saveDb("build", DB.build);
  saveDb("hero", DB.hero);
  saveDb("circle", DB.circle);
  saveDb("face", DB.face);
  saveDb("map", DB.map);
  callback({
    ok: [JSON.parse(JSON.stringify(DB.res)), JSON.parse(JSON.stringify(DB.build)), JSON.parse(JSON.stringify(DB.hero.own)), JSON.parse(JSON.stringify(DB.circle)), DB.face.unlock[3], effect_end, DB.map.city[2]]
  });
};

var read = function read(param, callback) {
  var rs = localStorage["circle"];

  if (rs) {
    DB.circle = JSON.parse(rs);
    callback({
      ok: JSON.parse(JSON.stringify(DB.circle))
    });
  } else {
    callback({
      err: 1
    });
  }
};

var plus = function plus(param, callback) {
  var costlist = [[1, 1, 1, 1], [1, 2, 2, 10], [3, 10, 15, 20, 20, 20, 20, 20, 20, 20]],
      cost;

  if (param[0] == 2) {
    var n = 0;

    for (var i = 0; i < DB.circle.temp[2].length; i++) {
      n += DB.circle.temp[2][i];
    }

    cost = costlist[2][n];
  } else {
    cost = costlist[param[0]][param[1]];
  }

  if (param[0] == 2 && DB.circle.temp[2][param[1]]) {
    callback({
      err: 2
    });
  } else if (cost > DB.circle.coin[0]) {
    callback({
      err: 1
    });
  } else {
    DB.circle.coin[0] -= cost;
    DB.circle.temp[param[0]][param[1]] += 1;
    saveDb("circle", DB.circle);
    callback({
      ok: [DB.circle.temp[param[0]][param[1]], DB.circle.coin[0]]
    });
  }
}; //轮回商店退款


var minus = function minus(param, callback) {
  var costlist = [[1, 1, 1, 1], [1, 2, 2, 10], [3, 10, 15, 20, 20, 20, 20, 20, 20, 20]],
      cost;

  if (param[0] == 2) {
    var n = 0;

    for (var i = 0; i < DB.circle.temp[2].length; i++) {
      n += DB.circle.temp[2][i];
    }

    cost = costlist[2][n - 1];
  } else {
    cost = costlist[param[0]][param[1]];
  }

  if (DB.circle.temp[param[0]][param[1]] == 0) {
    callback({
      err: 1
    });
  } else {
    DB.circle.coin[0] += cost;
    DB.circle.temp[param[0]][param[1]] -= 1;
    saveDb("circle", DB.circle);
    callback({
      ok: [DB.circle.temp[param[0]][param[1]], DB.circle.coin[0]]
    });
  }
};

_connect.default.setTest("app/circle@putin", putin);

_connect.default.setTest("app/circle@putout", putout);

_connect.default.setTest("app/circle@read", read);

_connect.default.setTest("app/circle@plus", plus);

_connect.default.setTest("app/circle@minus", minus);
/****************** date ******************/


var update_date = function update_date(param, callback) {
  DB.date.day[0] += 1;
  var day = DB.date.day[0],
      sea = Math.floor(day % 400 / 100);

  if (day % 100 == 1) {
    DB.res.food[4] = season[sea];
    console.log(localStorage.res);
    saveDb("res", DB.res);
  }

  console.log(localStorage.date);
  saveDb("date", DB.date);
  callback({
    ok: [DB.date.day[0], DB.res.food[4]]
  });
};

_connect.default.setTest("app/date@update", update_date);
/****************** res ******************/
//自动更新资源数据


var add_res = function add_res(param, callback) {
  var number = DB.res[param][1],
      max = DB.res[param][2],
      res = DB.res[param],
      people = DB.people[param],
      change = res[3] * (res[4] + 1) + people[1] * people[2] * (1 + people[3]),
      times = 1,
      index = res_name.indexOf(param);

  if (index < 4) {
    if (DB.res.win[1] > 0) {
      times += DB.people.win[2];
    }

    if (DB.res.fail[1] > 0) {
      times += -DB.people.fail[2];
    }

    if (DB.date.unlock[1]) {
      times += five_res[Math.floor(DB.date.day[0] / 400 + (DB.circle.city[0] && DB.circle.city[0][0] > 81 ? DB.circle.city[0][0] % 5 : 0)) % 5][index];
    }

    change = change * times / 2;
  }

  change -= res[5] * (1 + res[6]) / 2;

  if (change + number > max) {
    if (number < max) {
      number = max;
    } else {
      if (change < 0) {
        number += change;
      }
    }
  } else {
    if (number + change < 0) {
      number = 0;
    } else {
      number += change;
    }
  }

  DB.res[param][1] = number;
  saveDb("res", DB.res);
  callback({
    ok: DB.res[param][1]
  });
}; //自动增减人口


var change_people = function change_people(param, callback) {
  var people = DB.people.total[0],
      max = DB.people.total[1],
      food = DB.res.food[1],
      change = 0,
      over = -1;

  if (people < max && food > 0) {
    DB.people.total[0] += 1;
    change = 1;
    over = 0;
  }

  if (food <= 0 && max > 0) {
    if (DB.people.total[0] > 0) {
      DB.people.total[0] -= 1;
      over = 0;
    }

    for (var i = 1; i < 5; i++) {
      if (DB.people[work_name[i]][1] > 0 && over < 1) {
        DB.people[work_name[i]][1] -= 1;
        over = i;
      }
    }

    if (over > -1) {
      change = -1;
    }
  }

  saveDb("people", DB.people);
  callback({
    ok: [DB.people.total[0], change, over, over + 1 ? DB.people[work_name[over]][1] : 0]
  });
}; //手动加粮食


var manadd_food = function manadd_food(param, callback) {
  var number = DB.res.food[1],
      max = DB.res.food[5000],
      ismax = 0;

  if (number != max) {
    if (2 + number > max) {
      ismax = 1;
    } else {
      number += 5000;
    }
  }

  if (DB.build[0][0] < 1) {
    DB.build[0][0] += 0.2;
    DB.build[14][0] += 0.2;
    saveDb("build", DB.build);
  }

  DB.res.food[1] = number;
  saveDb("res", DB.res);
  callback({
    ok: [DB.res.food[1], DB.build[0][0], DB.build[14][0], ismax]
  });
};

var eat_food = function eat_food(param, callback) {
  DB.res.food[5] = DB.people.total[0] * 6;
  saveDb("res", DB.res);
  callback({
    ok: DB.res.food[5]
  });
}; //  const eat_gold = (param: any, callback) => {
//     DB.res.gold[5] = DB.army.total[0] *1;
//     saveDb("res",DB.res);
//     callback({ok:DB.res.gold[5]});  
// }


_connect.default.setTest("app/res@add", add_res);

_connect.default.setTest("app/res@manfood", manadd_food);

_connect.default.setTest("app/people@changepeople", change_people);

_connect.default.setTest("app/res@eatFood", eat_food); // Connect.setTest("app/res@eatGold",eat_gold);

/****************** build ******************/
//建筑升级


var levelup = function levelup(id, callback) {
  var bcfg = _cfgmrg.default.getOne("app/cfg/build.json@build"),
      bcfg2 = _cfgmrg.default.getOne("app/cfg/build.json@cost"),
      cost1 = bcfg2[DB.build[id - 1000][1] + 1]["a".concat(id)] * bcfg[id]["cost_number1"],
      cost_name1 = bcfg[id]["cost_type1"],
      cost_name2 = bcfg[id]["cost_type2"],
      num1 = DB.res[cost_name1][1],
      effect = bcfg[id]["effect_type"],
      effect_num = bcfg[id]["effect_number"],
      len = effect.length,
      //返回的效果结果
  effect_end = [],
      cost2,
      num2;

  if (cost_name2) {
    cost2 = bcfg2[DB.build[id - 1000][1] + 1]["a".concat(id)] * bcfg[id]["cost_number2"];
    num2 = DB.res[cost_name2][1];
  }

  if (DB.map.city[2] >= (DB.map.city[0] - DB.map.city[4]) * DB.map.city[3] + DB.map.city[5]) {
    callback({
      err: 1
    });
  } else if (num1 >= cost1 && (!cost_name2 || num2 >= cost2)) {
    //山路特殊处理
    if (id == 1014 && DB.build[0][1] < 5) {
      callback({
        err: 3
      });
      return;
    }

    num1 += cost1;
    DB.build[id - 1000][1] += 1;
    DB.res[cost_name1][1] = num1;
    DB.map.city[2] += 1;

    if (cost_name2) {
      num2 += cost2;
      DB.res[cost_name2][1] = num2;
    } //如果是仓库，额外追加


    if (id == 1005) {
      for (var i = 0; i < 4; i++) {
        var n = effect_num[i] * (DB.build[id - 1000][1] - 1);

        if (DB.build[id - 1000][1] > 65) {
          n = n * 10;
        } else if (DB.build[id - 1000][1] > 55) {
          n = n * 5;
        } else if (DB.build[id - 1000][1] > 45) {
          n = n * 3;
        } else if (DB.build[id - 1000][1] > 35) {
          n = n * 2;
        } else if (DB.build[id - 1000][1] > 25) {
          n;
          n = n * 1.5;
        }

        DB.res[res_name[i]][2] += n;
      }
    } //判断数据表


    for (var _i3 = 0; _i3 < effect_num.length; _i3++) {
      if (effect[_i3][2] == 0 && DB[effect[_i3][0]][effect[_i3][1]][effect[_i3][2]] >= 1 && (effect[_i3][1] == "sci" || effect[_i3][1] == "unlock")) {//如果是解锁学者和解锁界面，不再更新了
      } else {
        DB[effect[_i3][0]][effect[_i3][1]][effect[_i3][2]] += effect_num[_i3];
      }

      effect_end.push(DB[effect[_i3][0]][effect[_i3][1]][effect[_i3][2]]);
    } //英雄数量上限有上限


    if (DB.hero.MaxHero[1] > 9) {
      DB.hero.MaxHero[1] = 9;
    }

    saveDb("map", DB.map);
    saveDb("build", DB.build);
    saveDb("res", DB.res);
    saveDb("face", DB.face);
    saveDb("hero", DB.hero);
    saveDb("people", DB.people);
    saveDb("shop", DB.shop);
    callback({
      ok: [DB.build[id - 1000][1], num1, effect_end, cost_name2 ? num2 : null, DB.map.city[2]]
    });
  } else {
    callback({
      err: 2
    });
  }
};

_connect.default.setTest("app/build@levelup", levelup);
/****************** science ******************/
//解锁知识


var unlock = function unlock(id, callback) {
  var bcfg = _cfgmrg.default.getOne("app/cfg/science.json@science"),
      cost = bcfg[id]["cost"],
      effect = bcfg[id]["effect_type"],
      effect_num = bcfg[id]["effect_number"],
      len = effect.length,
      num = DB.res.sci[1],
      //返回的效果结果
  effect_end = [];

  if (DB.res.sci[1] >= cost) {
    num += cost;
    DB.science[id - 100][1] = 1;
    DB.res.sci[1] = num; //判断数据表

    for (var i = 0; i < effect_num.length; i++) {
      DB[effect[i][0]][effect[i][1]][effect[i][2]] += effect_num[i];
      effect_end.push(DB[effect[i][0]][effect[i][1]][effect[i][2]]);
    }

    saveDb("people", DB.people);
    saveDb("build", DB.build);
    saveDb("face", DB.face);
    saveDb("science", DB.science);
    saveDb("hero", DB.hero);
    saveDb("map", DB.map);
    saveDb("res", DB.res);
    saveDb("date", DB.date);
    console.log(localStorage.date);
    saveDb("army", DB.army);
    callback({
      ok: [DB.science[id - 100][1], num, effect_end]
    });
  } else {
    callback({
      err: 1
    });
  }
};

_connect.default.setTest("app/science@unlock", unlock);
/****************** people ******************/
//添加工作人


var people_plus = function people_plus(id, callback) {
  var p = DB.people;

  if (p.total[0] - p.food[1] - p.wood[1] - p.sci[1] - p.gold[1] > 0) {
    DB.people[id][1] += 1;
    saveDb("people", DB.people);
  }

  callback({
    ok: [DB.people[id][1]]
  });
}; //减少工作人


var people_minus = function people_minus(id, callback) {
  if (DB.people[id][1] > 0) {
    DB.people[id][1] -= 1;
    saveDb("people", DB.people);
  }

  callback({
    ok: [DB.people[id][1]]
  });
};

var people_zero = function people_zero(id, callback) {
  DB.people[id][1] = 0;
  saveDb("people", DB.people);
  callback({
    ok: [DB.people[id][1]]
  });
};

var people_max = function people_max(id, callback) {
  var name = ["food", "wood", "sci", "gold"],
      p = DB.people,
      all = p.total[0],
      index = name.indexOf(id);

  for (var i = 0; i < 4; i++) {
    if (i != index) {
      all -= p[name[i]][1];
    }
  }

  DB.people[id][1] = all;
  saveDb("people", DB.people);
  callback({
    ok: [DB.people[id][1]]
  });
};

_connect.default.setTest("app/people@people_plus", people_plus);

_connect.default.setTest("app/people@people_minus", people_minus);

_connect.default.setTest("app/people@people_zero", people_zero);

_connect.default.setTest("app/people@people_max", people_max);
/****************** event ******************/


var eventtrigger = function eventtrigger(eventId, callback) {
  var bcfg = _cfgmrg.default.getOne("app/cfg/event.json@event");

  DB.event.next[0] += 1;
  saveDb("event", DB.event); //判断事件的概率

  if ((0, _global.rand)(100) / 100 <= bcfg[eventId]["PR"]) {
    if (bcfg[eventId]["class"] == 1) {
      DB.hero.enemy = bcfg[eventId].type;
      DB.date.warning[1] = 0;
      DB.map.attack[0] = 1;
      saveDb("map", DB.map);
      saveDb("hero", DB.hero);
      saveDb("date", DB.date);
      console.log(localStorage.date);
      callback({
        ok: [DB.event.next[0], JSON.parse(JSON.stringify(DB.hero.enemy))]
      });
    } else if (bcfg[eventId]["class"] == 2) {
      callback({
        ok: [DB.event.next[0]]
      });
    } else {
      if (bcfg[eventId].type[0]) {
        DB[bcfg[eventId].type[0]][bcfg[eventId].type[1]][bcfg[eventId].type[2]] += bcfg[eventId].number;
        saveDb("build", DB.build);
        saveDb("face", DB.face);
        saveDb("science", DB.science);
        saveDb("hero", DB.hero);
        saveDb("map", DB.map);
        saveDb("res", DB.res);
        saveDb("date", DB.date);
        saveDb("event", DB.event);
        saveDb("army", DB.army);
        callback({
          ok: [DB.event.next[0], DB[bcfg[eventId].type[0]][bcfg[eventId].type[1]][bcfg[eventId].type[2]]]
        });
      } else {
        callback({
          ok: [DB.event.next[0]]
        });
      }
    }
  } else {
    callback({
      err: DB.event.next[0]
    });
  }
};

var warning_zero = function warning_zero(param, callback) {
  DB.date.warning[1] = 0;
  saveDb("date", DB.date);
  console.log(localStorage.date);
  callback({
    ok: [DB.date.warning[1]]
  });
};

_connect.default.setTest("app/event@eventtrigger", eventtrigger);

_connect.default.setTest("app/event@warning_zero", warning_zero);
/****************** hero ******************/
//param:（1给钱刷新，2时间刷新）


var hero_choose = function hero_choose(param, callback) {
  var now = Math.ceil(DB.date.day[0] / 400),
      bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
      bcfgP = _cfgmrg.default.getOne("app/cfg/build.json@p");

  if (DB.hotel.price[0] <= DB.res.gold[1] && param == 1) {
    DB.res.gold[1] -= DB.hotel.price[0];

    if (DB.hotel.price[0] > 100) {
      DB.hotel.price[0] = Math.ceil(1.5 * DB.hotel.price[0]);
    } else {
      DB.hotel.price[0] = Math.ceil(2 * DB.hotel.price[0]);
    }

    param = 3;
  }

  if (DB.hotel.date[0] < now && param == 2 || param == 3) {
    DB.hotel.date[0] = now;

    if (param == 2) {
      DB.hotel.price[0] = 10;
    }

    for (var i = 0; i < 3; i++) {
      var num = 0,
          rnd = (0, _global.rand)(10000),
          v = 0;

      for (var j = 0; j < 6; j++) {
        num += 100 * bcfgP[DB.build[7][1]]["color".concat(j)];

        if (rnd < num) {
          v = j;
          break;
        }
      } //如果该品质将领没有了


      if (DB.hero.left[v].length < 1) {
        v -= 1;
      }

      var heroId = Math.floor((0, _global.rand)(DB.hero.left[v].length)) - 1;
      DB.hero.choose.push(DB.hero.left[v][heroId]);
      DB.hero.left[v].splice(heroId, 1);

      if (DB.hero.choose[0] && DB.hero.choose.length > 3) {
        var c = bcfg[DB.hero.choose[0]]["color"];
        DB.hero.left[c].push(DB.hero.choose[0]);
        DB.hero.choose.splice(0, 1);
      }
    }
  }

  saveDb("hero", DB.hero);
  saveDb("hotel", DB.hotel);
  saveDb("res", DB.res);
  callback({
    ok: [JSON.parse(JSON.stringify(DB.hero.choose)), DB.res.gold[1], DB.hotel.price[0]]
  });
};

var hero_buy = function hero_buy(id, callback) {
  var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
      gold = bcfg[id]["gold"],
      choose_id = DB.hero.choose.indexOf(id);

  if (gold <= DB.res.gold[1]) {
    if (DB.hero.own.length < DB.hero.MaxHero[1]) {
      DB.res.gold[1] = DB.res.gold[1] - gold;
      DB.hero.choose.splice(choose_id, 1);
      DB.hero.own.push([id, 0, 0, DB.hero.own.length, 0]);
      saveDb("hero", DB.hero);
      saveDb("res", DB.res);
      callback({
        ok: [DB.res.gold[1], JSON.parse(JSON.stringify(DB.hero.choose)), JSON.parse(JSON.stringify(DB.hero.own)), choose_id]
      });
    } else {
      callback({
        err: 2
      });
    }
  } else {
    callback({
      err: 1
    });
  }
};

var hero_hurt = function hero_hurt(id, callback) {
  var health = [],
      pd = 0;

  for (var i = 0; i < DB.hero.own.length; i++) {
    if (DB.hero.own[i] && DB.hero.own[i][4] > 0) {
      DB.hero.own[i][4] -= 2;
      pd = 1;
    }
  }

  if (pd) {
    saveDb("hero", DB.hero);
    callback({
      ok: [JSON.parse(JSON.stringify(DB.hero.own))]
    });
  } else {
    callback({
      err: 1
    });
  }
};

_connect.default.setTest("app/hero@hurt", hero_hurt);

_connect.default.setTest("app/hero@choose", hero_choose);

_connect.default.setTest("app/hero@buy", hero_buy);
/****************** army ******************/
//位置上移


var army_up = function army_up(i, callback) {
  if (i > 0) {
    var t = DB.hero.own[i];
    DB.hero.own[i] = DB.hero.own[i - 1];
    DB.hero.own[i - 1] = t;
    DB.hero.own[i][3] = i;
    DB.hero.own[i - 1][3] = i - 1;
    saveDb("hero", DB.hero);
  }

  callback({
    ok: [JSON.parse(JSON.stringify(DB.hero.own))]
  });
};

var army_buy = function army_buy(id, callback) {
  if (!DB.army.price[2]) {
    DB.army.price.push(1);
  }

  var cost = DB.army.price[0] * DB.army.price[2],
      num;

  if (DB.army.cur[0] < DB.army.max[0]) {
    if (cost <= DB.res.gold[1]) {
      DB.res.gold[1] = DB.res.gold[1] - cost;
      num = Math.ceil(DB.army.price[1] * (400 + (0, _global.rand)(200)) / 500 - 0.5);

      if (DB.army.cur[0] + num > DB.army.max[0]) {
        DB.army.total[0] += DB.army.max[0] - DB.army.cur[0];
        DB.army.cur[0] = DB.army.max[0];
      } else {
        DB.army.total[0] += num;
        DB.army.cur[0] += num;
      }

      saveDb("army", DB.army);
      saveDb("res", DB.res);
      callback({
        ok: [DB.res.gold[1], DB.army.total[0], DB.army.cur[0]]
      });
    } else {
      callback({
        err: 1
      });
    }
  } else {
    callback({
      err: 2
    });
  }
}; //添加军人


var army_plus = function army_plus(id, callback) {
  var a = DB.army,
      bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
      max_army = bcfg[DB.hero.own[id][0]]["command"] + DB.hero.add[0];

  if (DB.hero.own[id][4] > 0) {
    callback({
      err: 4
    });
  } else if (a.cur[0] > 0) {
    if (max_army > DB.hero.own[id][1]) {
      if (DB.hero.MaxHero[2] >= DB.hero.MaxHero[0] && DB.hero.own[id][1] == 0) {
        callback({
          err: 3
        });
      } else {
        if (DB.hero.own[id][1] == 0) {
          DB.hero.MaxHero[2] += 1;
        }

        DB.hero.own[id][1] += 1;
        a.cur[0] -= 1;
        saveDb("army", DB.army);
        saveDb("hero", DB.hero);
        callback({
          ok: [DB.hero.own[id][1], a.cur[0], DB.hero.MaxHero[2]]
        });
      }
    } else {
      callback({
        err: 2
      });
    }
  } else {
    callback({
      err: 1
    });
  }
}; //减少军人


var army_minus = function army_minus(id, callback) {
  if (DB.hero.own[id][1] > 0) {
    DB.hero.own[id][1] -= 1;

    if (DB.hero.own[id][1] == 0) {
      DB.hero.MaxHero[2] -= 1;
    }

    DB.army.cur[0] += 1;
    saveDb("army", DB.army);
    saveDb("hero", DB.hero);
  }

  callback({
    ok: [DB.hero.own[id][1], DB.army.cur[0], DB.hero.MaxHero[2]]
  });
}; //删除将军


var hero_delete = function hero_delete(id, callback) {
  if (DB.hero.own[id]) {
    if (DB.hero.own[id][1]) {
      DB.hero.MaxHero[2] -= 1;
    }

    DB.army.cur[0] += DB.hero.own[id][1];
    DB.hero.own.splice(id, 1);

    for (var i = 0; i < DB.hero.own.length; i++) {
      if (DB.hero.own[i]) {
        DB.hero.own[i][3] = i;
      }
    }

    saveDb("hero", DB.hero);
    saveDb("army", DB.army);
  }

  callback({
    ok: [JSON.parse(JSON.stringify(DB.hero.own)), DB.army.cur[0], DB.hero.MaxHero[2]]
  });
};

var army_zero = function army_zero(id, callback) {
  if (DB.hero.own[id][1]) {
    DB.army.cur[0] += DB.hero.own[id][1];
    DB.hero.own[id][1] = 0;
    DB.hero.MaxHero[2] -= 1;
    saveDb("army", DB.army);
    saveDb("hero", DB.hero);
  }

  callback({
    ok: [DB.hero.own[id][1], DB.army.cur[0]]
  });
}; //满编


var army_max = function army_max(id, callback) {
  var a = DB.army,
      bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
      max_army = bcfg[DB.hero.own[id][0]]["command"] + DB.hero.add[0];

  if (DB.hero.own[id][4] > 0) {
    callback({
      err: 4
    });
  } else {
    if (a.cur[0] > 0) {
      if (DB.hero.MaxHero[2] >= DB.hero.MaxHero[0] && DB.hero.own[id][1] == 0) {
        callback({
          err: 3
        });
      } else {
        if (DB.hero.own[id][1] == 0) {
          DB.hero.MaxHero[2] += 1;
        }

        if (a.cur[0] + DB.hero.own[id][1] > max_army) {
          a.cur[0] -= max_army - DB.hero.own[id][1];
          DB.hero.own[id][1] = max_army;
        } else {
          DB.hero.own[id][1] += a.cur[0];
          a.cur[0] = 0;
        }

        saveDb("army", DB.army);
        saveDb("hero", DB.hero);
        callback({
          ok: [DB.hero.own[id][1], DB.army.cur[0], DB.hero.MaxHero[2]]
        });
      }
    } else {
      callback({
        err: 1
      });
    }
  }
};

_connect.default.setTest("app/army@army_buy", army_buy);

_connect.default.setTest("app/army@army_plus", army_plus);

_connect.default.setTest("app/army@army_minus", army_minus);

_connect.default.setTest("app/army@army_zero", army_zero);

_connect.default.setTest("app/army@army_max", army_max);

_connect.default.setTest("app/army@hero_delete", hero_delete);

_connect.default.setTest("app/army@army_up", army_up);
/****************** map ******************/


var guard_add = function guard_add(id, callback) {
  var bcfg = _cfgmrg.default.getOne("app/cfg/city.json@city"),
      bcfg2 = _cfgmrg.default.getOne("app/cfg/city.json@rand"),
      bcfg3 = _cfgmrg.default.getOne("app/cfg/city.json@army"),
      guard = [],
      guardId;

  if (DB.map.guard.length >= 3) {
    DB.map.date[0] = 999999999;
    saveDb("map", DB.map);
    callback({
      err: 1
    });
  } else {
    var rnd = (0, _global.rand)(30); //随机据点

    if (bd_rand < 6 && (rnd > 10 || bd_city > 1) || DB.map.guard.length == 2) {
      bd_rand += 1;
      bd_city = 0;
      guardId = 20000 + (0, _global.rand)(3);

      for (var i = 0; i < bcfg3[Math.ceil(DB.date.day[0] / 400)]["army"].length; i++) {
        guard.push([bcfg2[guardId]["army"], Math.ceil(bcfg3[Math.ceil(DB.date.day[0] / 400)]["army"][i] * (450 + (0, _global.rand)(100)) / 500 - 0.5)]);
      } //城市据点

    } else {
      bd_city += 1;
      bd_rand = 0;
      guardId = DB.map.city[1] + 1;
      DB.map.city[1] += 1; //判断时间段

      var time = bcfg[guardId]["time"],
          army = bcfg[guardId]["army"],
          hero = bcfg[guardId]["hero"],
          index = 0;

      for (var _i4 = 0; _i4 < time.length; _i4++) {
        if (DB.event.date[0] >= time[_i4]) {
          index += 1;
        } else {
          break;
        }
      }

      for (var _i5 = 0; _i5 < army.length; _i5++) {
        guard.push([hero[index][_i5], army[_i5]]);
      }
    }

    guard.splice(0, 0, guardId);
    DB.map.guard.push(guard);
    saveDb("map", DB.map);
    callback({
      ok: [JSON.parse(JSON.stringify(DB.map.guard)), guardId, DB.map.city[1]]
    });
  }
};

var date_update = function date_update(date, callback) {
  DB.map.date[0] = date;
  saveDb("map", DB.map);
  callback({
    ok: [DB.map.date[0]]
  });
};

_connect.default.setTest("app/map@guard_add", guard_add);

_connect.default.setTest("app/map@date_update", date_update);
/****************** fight ******************/
//fighter:[id,num,add+1,位置,兵种]
//param[fighter,敌人种类,]
//特性fa = [蜀魏吴美医忠勇威智谋枭狠全]


var fight = function fight(param, callback) {
  var num = [],
      fighter = param[0],
      group_num = [fighter[0].length, fighter[1].length, fighter[0].length + fighter[1].length],
      oder = [],
      //出手顺序
  dead = [0, 0],
      //死亡数量
  cur = _util.default.copy(fighter),
      //存活的角色
  mess = [],
      //战斗报文
  isvic = 0,
      //是否胜利
  army_dead = [0, 0],
      kill_die = [[0, 0, 0, 0], [0, 0, 0, 0]],
      //我军将领得杀敌与损伤
  enemyType = param[1] > -1 ? DB.map.guard[param[1]] : DB.hero.enemy,
      fa = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      armys_add = [2, 0, 1],
      //增加伤害的兵种
  armys_red = [1, 2, 0],
      //减少伤害的兵种
  bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@fature"),
      enemymax = [0, 0, 0];

  for (var i = 0; i < fighter[1].length; i++) {
    enemymax[i] = fighter[1][i][1];
  } //添加特性


  for (var _i6 = 0; _i6 < param[2].length; _i6++) {
    fa[param[2][_i6]] = 1;
  } //计算战斗力


  for (var _i7 = 0; _i7 < 2; _i7++) {
    for (var j = 0; j < group_num[_i7]; j++) {
      fighter[_i7][j][5] = fighter[_i7][j][1] * fighter[_i7][j][2];
      cur[_i7][j][5] = j;
    }
  }

  for (var _i8 = 0; _i8 < group_num[2]; _i8++) {
    num.push([1, group_num[0] - _i8 > 0 ? 0 : 1, group_num[0] - _i8 > 0 ? _i8 : _i8 - group_num[0]]);
  } //出手顺序确定


  if (fa[3]) {
    oder = num;
  } else {
    for (var _i9 = 0; _i9 < group_num[2]; _i9++) {
      var rnd = (0, _global.rand)(num.length) - 1;
      oder.push(num[rnd]);
      num.splice(rnd, 1);
    }
  }

  while (!(dead[0] == group_num[0]) && !(dead[1] == group_num[1])) {
    for (var _i10 = 0; _i10 < oder.length; _i10++) {
      if (fighter[oder[_i10][1]][oder[_i10][2]][1]) {
        var group = Math.abs(oder[_i10][1] - 1),
            _rnd = (0, _global.rand)(cur[group].length) - 1,
            enemyId = cur[group][_rnd][5],
            armys = fighter[oder[_i10][1]][oder[_i10][2]][4],
            e_armys = fighter[group][enemyId][4],
            damage = fighter[oder[_i10][1]][oder[_i10][2]][5] / 4,
            die = 0,
            add = 1,
            red = 1; //兵种克制


        if (armys_add[armys] == e_armys) {
          add += 0.3;
        } else if (armys_red[armys] == e_armys) {
          red -= 0.2;
        } //攻击敌方时阵法


        if (oder[_i10][1] == 0) {
          //战魂克制
          if (fa[e_armys]) {
            add += bcfg["".concat(e_armys)]["effect"];
          }

          if (fa[6]) {
            add += bcfg["6"]["effect"];
          }

          if (fa[7]) {
            add += bcfg["7"]["effect"];
            fa[7] = 0;
          }

          if (fa[11] && fighter[1][enemyId][1] / enemymax[enemyId] <= 0.5) {
            add += bcfg["11"]["effect"];
          }

          if (fa[5] && dead[0]) {
            add += bcfg["5"]["effect"];
          } //己方被攻击时阵法

        } else {
          if (fa[10]) {
            red -= bcfg["10"]["effect"];
          }

          if (fa[8]) {
            damage = 0;
            fa[8] = 0;
          }

          if (fa[12]) {
            red -= bcfg["12"]["effect"];
            damage = damage / (group_num[0] - dead[0] ? group_num[0] - dead[0] : 1);
          }
        }

        damage = Math.ceil(damage * add * red / fighter[group][enemyId][2]); //如果有群英荟萃，单独处理伤害

        if (oder[_i10][1] && fa[12]) {
          for (var _j = 0; _j < fighter[0].length; _j++) {
            if (fighter[0][_j][1]) {
              //打死了    
              if (fighter[0][_j][1] <= damage) {
                die += fighter[0][_j][1];
                fighter[0][_j][1] = 0;
                cur[0].splice(_j, 1);
                dead[0] += 1; //没打死
              } else {
                die += damage;
                fighter[0][_j][1] -= damage;
              }
            }
          }
        } else {
          //打死了    
          if (fighter[group][enemyId][1] <= damage) {
            die = fighter[group][enemyId][1];
            fighter[group][enemyId][1] = 0;
            cur[group].splice(_rnd, 1);
            dead[group] += 1; //没打死
          } else {
            die = damage;
            fighter[group][enemyId][1] -= die;
          }
        } //战斗报文 [攻武将ID，攻阵营，攻位置，防武将ID，防阵营，防位置，死伤数]


        mess.push([fighter[oder[_i10][1]][oder[_i10][2]][0], oder[_i10][1], oder[_i10][2], fighter[group][enemyId][0], group, enemyId, die]);

        if (oder[_i10][1]) {
          kill_die[1][enemyId] += die;
        } else {
          kill_die[0][oder[_i10][2]] += die;
        }

        if (dead[0] == group_num[0] || dead[1] == group_num[1]) {
          break;
        }
      }
    }
  } //判断是否胜利


  if (dead[1] == group_num[1]) {
    isvic = 1;
  } // 军队数量保存


  for (var _i11 = group_num[0] - 1; _i11 >= 0; _i11--) {
    army_dead[0] += DB.hero.own[fighter[0][_i11][3]][1] - fighter[0][_i11][1];
    DB.hero.own[fighter[0][_i11][3]][1] = fighter[0][_i11][1];
  }

  if (isvic) {
    if (param[1] > -1) {
      DB.map.guard.splice(param[1], 1);
    } else {
      DB.hero.enemy = [];
    }
  } else {
    var t = 0;

    if (enemyType[0][1] == undefined) {
      t = 1;
    }

    for (var _i12 = group_num[1] - 1; _i12 >= 0; _i12--) {
      army_dead[1] += enemyType[_i12 + t][1] - fighter[1][_i12][1];

      if (!fighter[1][_i12][1]) {
        enemyType.splice(_i12 + t, 1);
      } else {
        enemyType[_i12 + t][1] = fighter[1][_i12][1];
      }
    }
  }

  DB.army.total[0] -= army_dead[0];
  var add_army = 0;

  if (fa[9]) {
    add_army = Math.ceil(army_dead[0] * bcfg["9"]["effect"]);
    DB.army.total[0] += add_army;
    DB.army.cur[0] += add_army;
  }

  saveDb("hero", DB.hero);
  saveDb("army", DB.army);
  saveDb("map", DB.map);
  callback({
    ok: [isvic, mess, JSON.parse(JSON.stringify(DB.hero.own)), JSON.parse(JSON.stringify(param[1] > -1 ? DB.map.guard : DB.hero.enemy)), DB.army.total[0], kill_die, DB.army.cur[0], add_army]
  });
};

var fightAccount = function fightAccount(param, callback) {
  var bcfg = _cfgmrg.default.getOne("app/cfg/city.json@city");

  if (param.cityId >= 20000 && param.cityId < 30000) {
    bcfg = _cfgmrg.default.getOne("app/cfg/city.json@rand");
  }

  var effect = bcfg[param.cityId]["effect_type"],
      effect_num = bcfg[param.cityId]["effect_number"],
      effect_end = [];

  if (param.isvic) {
    var win = bcfg[param.cityId]["win"]; //加胜绩

    if (DB.res.fail[1] > win) {
      DB.res.fail[1] -= win;
    } else {
      if (DB.res.win[1] + win - DB.res.fail[1] <= DB.res.win[2]) {
        DB.res.win[1] += win - DB.res.fail[1];
      } else {
        DB.res.win[1] = DB.res.win[2];
      }

      DB.res.fail[1] = 0;
    }

    if (effect) {
      for (var i = 0; i < effect_num.length; i++) {
        DB[effect[i][0]][effect[i][1]][effect[i][2]] += effect_num[i];
        effect_end.push(DB[effect[i][0]][effect[i][1]][effect[i][2]]);
      }
    } //收复城池


    if (param.cityId == 19999) {
      DB.map.city[4] = 0;
      DB.map.attack[0] = 0;
    } //加武将能力,添加受伤状态


    var a = [900, 600, 300, 200, 100, 95, 90, 80, 70, 50, 30, 0],
        b = [0.01, 0.02, 0.03, 0.06, 0.09, 0.1, 0.11, 0.12, 0.2, 0.3, 0.5, 0.8];

    for (var _i13 = 0; _i13 < param.heroIndex.length; _i13++) {
      var hero = DB.hero.own[param.heroIndex[_i13]],
          _bcfg2 = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          num = _bcfg2[hero[0]]["number"];

      for (var j = 0; j < a.length; j++) {
        if (num + hero[2] > a[j]) {
          hero[2] += b[j];
          break;
        }
      }

      if (hero[1] == 0) {
        hero[4] = 100;

        if (param.fa4) {
          hero[4] = 50;
        }

        DB.hero.MaxHero[2] -= 1;
      }
    }

    saveDb("hero", DB.hero);
    saveDb("map", DB.map);
    saveDb("res", DB.res);
    callback({
      ok: [DB.res.fail[1], DB.res.win[1], effect_end, JSON.parse(JSON.stringify(DB.hero.own)), DB.hero.MaxHero[2], DB.map.city[4]]
    });
  } else {
    //加败绩
    var fail = 50;

    if (DB.res.win[1] > fail) {
      DB.res.win[1] -= fail;
    } else {
      DB.res.fail[1] += fail - DB.res.win[1];
      DB.res.win[1] = 0;
    }

    for (var _i14 = 0; _i14 < param.heroIndex.length; _i14++) {
      var _hero = DB.hero.own[param.heroIndex[_i14]];

      if (_hero[1] == 0) {
        _hero[4] = 100;

        if (param.fa4) {
          _hero[4] = 50;
        }

        DB.hero.MaxHero[2] -= 1;
      }
    }

    if (param.cityId == 19999) {
      if (DB.map.city[4] == 0) {
        DB.map.city[4] += Math.ceil(DB.map.city[0] / 2);
        DB.map.attack[0] = 0;
      } else {
        DB.map.city[4] = DB.map.city[0];
      }
    }

    saveDb("map", DB.map);
    saveDb("hero", DB.hero);
    saveDb("res", DB.res);
    callback({
      ok: [DB.res.fail[1], DB.res.win[1], "no", JSON.parse(JSON.stringify(DB.hero.own)), DB.hero.MaxHero[2], DB.map.city[4]]
    });
  }
};

var lose = function lose(param, callback) {
  if (DB.map.city[4]) {
    callback({
      err: 1
    });
  } else {
    DB.map.attack[0] = 0;
    DB.map.city[4] += Math.ceil(DB.map.city[0] / 2);
    var fail = 50;

    if (DB.res.win[1] > fail) {
      DB.res.win[1] -= fail;
    } else {
      DB.res.fail[1] += fail - DB.res.win[1];
      DB.res.win[1] = 0;
    }

    saveDb("map", DB.map);
    saveDb("res", DB.res);
    callback({
      ok: [DB.map.city[4], DB.res.fail[1], DB.res.win[1]]
    });
  }
};

_connect.default.setTest("app/fight@fight", fight);

_connect.default.setTest("app/fight@fightAccount", fightAccount);

_connect.default.setTest("app/fight@lose", lose);
/****************** shop ******************/
//市场资源价格


var buy = function buy(param, callback) {
  var goods = [["gold", "food"], ["gold", "wood"], ["gold", "sci"], ["food", "gold"], ["wood", "gold"], ["sci", "gold"]],
      price = [0.125, 1, 1, 8, 1, 1],
      times = 1.05,
      num = DB.shop.price[param] * DB.shop.number[0],
      n;
  n = (0, _global.number1)(num); //购买某种商品后刷新价格

  if (DB.res[goods[param][0]][1] >= n) {
    if (DB.res[goods[param][1]][1] + DB.shop.number[0] <= DB.res[goods[param][1]][2]) {
      DB.res[goods[param][0]][1] -= n;
      DB.res[goods[param][1]][1] += DB.shop.number[0];

      if (DB.shop.price[param] < price[param]) {
        times = 1.1;
      }

      DB.shop.price[param] = DB.shop.price[param] * times;
      saveDb("res", DB.res);
      saveDb("shop", DB.shop);
      callback({
        ok: [DB.res[goods[param][0]][1], DB.res[goods[param][1]][1], DB.shop.price[param]]
      });
    } else {
      callback({
        err: 2
      });
    }
  } else {
    callback({
      err: 1
    });
  }
};

var updateShop = function updateShop(param, callback) {
  var discount = (0, _global.rand)(6) - 1,
      price = [0.125, 1, 1, 8, 1, 1];

  for (var i = 0; i <= 5; i++) {
    DB.shop.price[i] = price[i];
  }

  DB.shop.price[discount] = price[discount] * 0.4;
  DB.shop.date[0] = Math.ceil(DB.date.day[0] / 100);
  saveDb("shop", DB.shop);
  callback({
    ok: [discount, DB.shop.price, DB.shop.date[0]]
  });
};

_connect.default.setTest("app/shop@buy", buy);

_connect.default.setTest("app/shop@updateShop", updateShop);
/****************** news ******************/
//市场资源价格


var addNews = function addNews(param, callback) {
  DB.news[param.id].unshift(param.news);

  if (DB.news[param.id].length > 24) {
    DB.news[param.id].splice(-1, 1);
  }

  saveDb("news", DB.news);
  callback({
    ok: [DB.news[param.id]]
  });
};

_connect.default.setTest("app/news@addNews", addNews); //注册页面打开事件


_appEmitter.AppEmitter.add("initDB", function (node) {
  initDB();
});
})