define("app/people",function(require,exports,module){
"use strict";

var _scene = _interopRequireDefault(require("libs/ni/scene"));

var _db = _interopRequireDefault(require("libs/ni/db"));

var _widget = _interopRequireDefault(require("libs/ni/widget"));

var _appEmitter = require("app/appEmitter");

var _connect = _interopRequireDefault(require("libs/ni/connect"));

var _global = require("app/global");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/****************** 导出 ******************/

/****************** 本地 ******************/
var workNode = [];
var peopleNode = [];

var People =
/*#__PURE__*/
function () {
  function People() {
    _classCallCheck(this, People);
  }

  _createClass(People, null, [{
    key: "initDB",
    value: function initDB() {
      //初始化人口数据库 [解锁，数量，提供单位资源量，效率提升百分比],total:[总人口数，人口上限]
      _db.default.init("people", {
        total: [0, 0],
        food: [0, 0, 8, 0],
        wood: [0, 0, 1, 0],
        sci: [0, 0, 1, 0],
        gold: [0, 0, 1, 0],
        win: [0, 0, 0.25, 0],
        fail: [0, 0, 0.25, 0]
      });
    }
  }, {
    key: "eatFood",
    value: function eatFood() {
      _connect.default.request({
        type: "app/res@eatFood",
        arg: {}
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        }

        _db.default.data.res.food[5] = data.ok;
      });
    }
  }, {
    key: "updateUnlock",
    value: function updateUnlock(id) {
      if (_global.Global.mainFace.id != 1 && _db.default.data.people[People.work_name[id]][0] >= 1) {
        _db.default.data.face.new[1] = 1;
      }
    }
  }, {
    key: "updatePeople",
    value: function updatePeople(id) {
      var p = _db.default.data.people,
          work = 0;

      if (peopleNode[id] != undefined) {
        if (_global.Global.mainFace.id == 1) {
          for (var i = 1; i < 5; i++) {
            if (p[People.work_name[i]][0]) {
              work += p[People.work_name[i]][1];
            }
          }

          peopleNode[id].text = "".concat(p.total[0] - work, "/").concat(_db.default.data.people.total[1]);
        } else {
          _db.default.data.face.new[1] = 1;
        }
      }
    }
  }, {
    key: "updateWork",
    value: function updateWork(id) {
      if (workNode[id] != undefined && _global.Global.mainFace.id == 1) {
        workNode[id].text = "".concat(People.work_Cname[id], "\n(").concat(_db.default.data.people[People.work_name[id]][1], ")");
      }
    }
  }]);

  return People;
}();
/**
 * @description  添人按钮组件
 */


People.people_sprite = [];
People.work_Cname = ["空闲人口", "农民", "樵夫", "学者", "矿工"];
People.work_name = ["total", "food", "wood", "sci", "gold"];
People.work_top = [370, 650, 430, 540, 760];
People.work_dis = [0, "每个农民+8粮食/秒", "每个樵夫+1木材/秒", "每个学者+1知识/秒", "每个矿工+1黄金/秒"];

var WWork =
/*#__PURE__*/
function (_Widget) {
  _inherits(WWork, _Widget);

  function WWork() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, WWork);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(WWork)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.backNode = void 0;
    return _this;
  }

  _createClass(WWork, [{
    key: "setProps",
    value: function setProps(props) {
      var id = props.id,
          name = People.work_name[id];

      _get(_getPrototypeOf(WWork.prototype), "setProps", this).call(this, props);

      this.cfg.children[0].children[0].data.text = "".concat(People.work_Cname[id], "\n(").concat(_db.default.data.people[name][1], ")");
      this.cfg.data.top = People.work_top[id];
      this.cfg.children[0].on = {
        "tap": {
          "func": "dis_work",
          "arg": [id]
        }
      };
      this.cfg.children[1].props.on = {
        "tap": {
          "func": "people_plus",
          "arg": [name]
        }
      };
      this.cfg.children[2].props.on = {
        "tap": {
          "func": "people_minus",
          "arg": [name]
        }
      };
      this.cfg.children[3].props.on = {
        "tap": {
          "func": "people_max",
          "arg": [name]
        }
      };
      this.cfg.children[4].props.on = {
        "tap": {
          "func": "people_zero",
          "arg": [name]
        }
      };
      var n = Math.floor((_scene.default.screen.width - 230 - 4 * 90) / 6);
      this.cfg.children[1].props.left = 200 + 2 * n + 45;
      this.cfg.children[2].props.left = 200 + 3 * n + 45 + 90;
      this.cfg.children[3].props.left = 200 + 4 * n + 45 + 180;
      this.cfg.children[4].props.left = 200 + 5 * n + 45 + 270;
    }
  }, {
    key: "dis_work",
    value: function dis_work(type) {
      _appEmitter.AppEmitter.emit("stagePause");

      this.backNode = _scene.default.open("app-ui-back", _scene.default.root);

      _scene.default.open("app-ui-workDis", this.backNode, null, {
        id: type
      });
    } //加1个人

  }, {
    key: "people_plus",
    value: function people_plus(id) {
      _connect.default.request({
        type: "app/people@people_plus",
        arg: id
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        }

        _db.default.data.people[id][1] = data.ok[0];
      });
    } //减1个人

  }, {
    key: "people_minus",
    value: function people_minus(id) {
      _connect.default.request({
        type: "app/people@people_minus",
        arg: id
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        }

        _db.default.data.people[id][1] = data.ok[0];
      });
    } //人数清0

  }, {
    key: "people_zero",
    value: function people_zero(id) {
      _connect.default.request({
        type: "app/people@people_zero",
        arg: id
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        }

        _db.default.data.people[id][1] = data.ok[0];
      });
    } //人数全部

  }, {
    key: "people_max",
    value: function people_max(id) {
      _connect.default.request({
        type: "app/people@people_max",
        arg: id
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        }

        _db.default.data.people[id][1] = data.ok[0];
      });
    }
  }, {
    key: "added",
    value: function added(node) {
      workNode[node.widget.props.id] = this.elements.get("button_work");
    }
  }]);

  return WWork;
}(_widget.default);
/**
 * @description  人口界面组件
 */


var WPeople =
/*#__PURE__*/
function (_Widget2) {
  _inherits(WPeople, _Widget2);

  function WPeople() {
    _classCallCheck(this, WPeople);

    return _possibleConstructorReturn(this, _getPrototypeOf(WPeople).apply(this, arguments));
  }

  _createClass(WPeople, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WPeople.prototype), "setProps", this).call(this, props);

      var work = 0,
          p = _db.default.data.people;

      for (var i = 1; i < 5; i++) {
        if (p[People.work_name[i]][0]) {
          work += p[People.work_name[i]][1];
        }
      }

      this.cfg.children[1].data.text = "".concat(p.total[0] - work, "/").concat(_db.default.data.people.total[1]);
      this.cfg.children[5].data.width = 350 + _scene.default.screen.width - 750; //    this.cfg.children[3].data.text = DB.data.people.total[1];
    }
  }, {
    key: "added",
    value: function added(node) {
      peopleNode[0] = this.elements.get("people_number");
      peopleNode[1] = this.elements.get("people_max");
    }
  }]);

  return WPeople;
}(_widget.default); //工作介绍弹窗


var WworkDis =
/*#__PURE__*/
function (_Widget3) {
  _inherits(WworkDis, _Widget3);

  function WworkDis() {
    var _getPrototypeOf3;

    var _this2;

    _classCallCheck(this, WworkDis);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _possibleConstructorReturn(this, (_getPrototypeOf3 = _getPrototypeOf(WworkDis)).call.apply(_getPrototypeOf3, [this].concat(args)));
    _this2.node = void 0;
    return _this2;
  }

  _createClass(WworkDis, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WworkDis.prototype), "setProps", this).call(this, props);

      var id = props.id;
      this.cfg.data.left = Math.floor(_scene.default.screen.width - this.cfg.data.width) / 2;
      this.cfg.children[1].data.text = "".concat(People.work_Cname[id], "(").concat(_db.default.data.people[People.work_name[id]][1], ")");
      this.cfg.children[2].data.text = People.work_dis[id];
    }
  }]);

  return WworkDis;
}(_widget.default);
/**
 * @description 打开人口界面
 */


var open = function open() {
  _global.Global.mainFace.node = _scene.default.open("app-ui-people", _scene.default.root);
  _global.Global.mainFace.id = 1; //显示解锁的工作按钮

  for (var i = 1; i < 5; i++) {
    if (_db.default.data.people[People.work_name[i]][0]) {
      People.people_sprite = _scene.default.open("app-ui-peopleWork", _global.Global.mainFace.node, null, {
        id: i
      });
    }
  }
};
/****************** 立即执行 ******************/
//注册组件


_widget.default.registW("app-ui-people", WPeople);

_widget.default.registW("app-ui-peopleWork", WWork);

_widget.default.registW("app-ui-workDis", WworkDis); //注册人口监听


for (var i = 0; i < 2; i++) {
  _db.default.emitter.add("people.total.".concat(i), function (x) {
    return function () {
      People.updatePeople(x);
    };
  }(i));
} //注册工作监听


for (var _i = 1; _i < 5; _i++) {
  _db.default.emitter.add("people.".concat(People.work_name[_i], ".1"), function (x) {
    return function () {
      People.updatePeople(x);
    };
  }(0));
} //注册工作监听


for (var _i2 = 1; _i2 < 5; _i2++) {
  _db.default.emitter.add("people.".concat(People.work_name[_i2], ".1"), function (x) {
    return function () {
      People.updateWork(x);
    };
  }(_i2));
} //注册工作解锁监听


for (var _i3 = 1; _i3 < 5; _i3++) {
  _db.default.emitter.add("people.".concat(People.work_name[_i3], ".0"), function (x) {
    return function () {
      People.updateUnlock(x);
    };
  }(_i3));
}

_db.default.emitter.add("people.total.0", function () {
  People.eatFood();
}); //注册页面打开事件


_appEmitter.AppEmitter.add("intoPeople", function (node) {
  open();
}); //初始化数据库


_appEmitter.AppEmitter.add("initDB", function (node) {
  People.initDB();
});
})