define("libs/bd/fs",function(require,exports,module){
"use strict";

var _util = _interopRequireDefault(require("libs/ni/util"));

var _fs = _interopRequireDefault(require("libs/ni/fs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var swanFS =
/*#__PURE__*/
function () {
  function swanFS(cfg, callback) {
    var _this2 = this;

    _classCallCheck(this, swanFS);

    this.fs = void 0;
    this.userDir = "";
    this.depend = void 0;
    this.waitDir = {};
    this.localRes = false;
    this.except = [".js"];
    this.isReady = false;
    this.fs = swan.getFileSystemManager();
    this.localRes = cfg.localRes;

    if (!cfg.localRes) {
      this.userDir = swan.env.USER_DATA_PATH + "/";
      this.read("_.depend", function (err, data) {
        _this2.depend = err ? {} : JSON.parse(data);
        callback && callback();
      });
    } else {
      callback && callback();
    }
  }

  _createClass(swanFS, [{
    key: "isLocal",
    value: function isLocal(path, sign) {
      return this.localRes || this.depend[path] == sign;
    }
  }, {
    key: "read",
    value: function read(path, callback) {
      this.fs.readFile({
        filePath: "".concat(this.userDir).concat(path),
        encoding: _fs.default.BlobType[_util.default.fileSuffix(path)] ? "" : "utf8",
        success: function success(data) {
          callback(null, data.data);
        },
        fail: function fail(error) {
          callback(error, null);
        }
      });
    }
  }, {
    key: "write",
    value: function write(path, data, callback, notWriteDepend) {
      var _this3 = this;

      var dir = _util.default.fileDir(path);

      this.mkDir(dir);
      this.fs.writeFile({
        filePath: "".concat(this.userDir).concat(path),
        data: data,
        encoding: typeof data == "string" ? "utf8" : "binary",
        success: function success() {
          callback(null, "".concat(_this3.userDir).concat(path)); // console.log(path);

          if (!notWriteDepend) {
            _this3.depend[path] = _fs.default.depend.all[path].sign;

            _fs.default.writeCacheDpend();
          }
        },
        fail: function fail(error) {
          callback(error, null);
        }
      });
    }
  }, {
    key: "get",
    value: function get(path, remote, callback) {
      var _this4 = this;

      var _this = this,
          header = {},
          binary = _fs.default.BlobType[_util.default.fileSuffix(path)];

      if (binary) {
        header["content-type"] = "application/octet-stream";
      }

      swan.downloadFile({
        url: "".concat(remote, "/").concat(path),
        filePath: "".concat(this.userDir).concat(path),
        header: header,
        success: function success(res) {
          // console.log(res);
          _this4.depend[path] = _fs.default.depend.all[path].sign;

          if (binary) {
            callback(null, res);
          } else {
            _fs.default.writeCacheDpend();

            _this.read(path, function (err, data) {
              callback(err, data);
            });
          }
        },
        fail: function fail(error) {
          callback(error, null);
        }
      });
    }
  }, {
    key: "mkDir",
    value: function mkDir(dir) {
      dir = dir.replace(/\/$/, "");

      if (!dir) {
        return;
      }

      try {
        this.fs.statSync("".concat(this.userDir).concat(dir));
      } catch (e) {
        try {
          this.fs.mkdirSync("".concat(this.userDir).concat(dir), true);
        } catch (err) {
          console.log(e, err);
        }
      }
    }
  }, {
    key: "createImg",
    value: function createImg(path, data) {
      return "".concat(this.userDir).concat(path);
    }
    /**
     * @description 写入缓存depend
     * @param callback 
     */

  }, {
    key: "writeDepend",
    value: function writeDepend(callback) {
      this.write("_.depend", JSON.stringify(this.depend), function (err) {
        callback(err);
      }, true);
    }
    /**
        * @description 添加字体
        * @param path 
        */

  }, {
    key: "addFont",
    value: function addFont(path) {
      console.log("".concat(this.userDir).concat(path));
      var r = swan.loadFont("".concat(this.userDir).concat(path));
      console.log(r);
    }
  }]);

  return swanFS;
}();
/****************** 立即执行 ******************/


_fs.default.createFs = function (cfg, callback) {
  _fs.default.fs = new swanFS(cfg, function () {
    if (!cfg.localRes) {
      _fs.default.fs.mkDirs();
    }

    callback();
  });
};
})