define("libs/bd/user",function(require,exports,module){
"use strict";

var _fs = _interopRequireDefault(require("libs/ni/fs"));

var _db = _interopRequireDefault(require("libs/ni/db"));

var _scene = _interopRequireDefault(require("libs/ni/scene"));

var _music = _interopRequireDefault(require("libs/ni/music"));

var _connect = _interopRequireDefault(require("libs/ni/connect"));

var _emitter = _interopRequireDefault(require("libs/ni/emitter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/****************** 导入 ******************/

/****************** 导出 ******************/
var login_swan = function login_swan() {
  if (userInfo == undefined || !code) {
    return;
  }

  _connect.default.request({
    type: "app/bd@login",
    arg: {
      "code": code,
      "encrypted": userInfo.data,
      "gamename": _fs.default.appName,
      "iv": userInfo.iv
    }
  }, function (data) {
    if (data.err) {
      return console.log(data.err.reson);
    }

    _db.default.data.user.uid = data.ok.uid;
    _db.default.data.user.from = "baidu";
    _db.default.data.user.name = data.ok.name;
    _db.default.data.user.head = data.ok.head;
    _db.default.data.user.username = data.ok.username;
    _db.default.data.user.isnew = data.ok.regist;
    userInfo && (_db.default.data.user.info = userInfo);
    successBack("baidu");
  });
};
/****************** 本地 ******************/


var userInfo, code, swanButton, successBack, failBack;
/**
 * @description 平台授权初始化
 */

var swanLogin = function swanLogin() {
  var swan = window.swan,
      createButton = function createButton() {
    if (swanButton) {
      swanButton.destroy();
    }

    var scale = _scene.default.screen.scale,
        w = Math.floor(386 / scale),
        h = Math.floor(140 / scale);
    swanButton = swan.createUserInfoButton({
      type: 'image',
      image: "images/btn.png",
      style: {
        left: swan.getSystemInfoSync().windowWidth / 2 - w / 2,
        top: swan.getSystemInfoSync().windowHeight - h - 200 / scale,
        width: w,
        height: h
      }
    });
    swanButton.onTap(function (res) {
      _music.default.play("audio/butn.mp3");

      if (res.errMsg == "getUserInfo:ok") {
        userInfo = res; //清除微信授权按钮

        swanButton.destroy();
        swanButton = null;
        login_swan();
      } else {
        console.log("swan authorize fail");
        swanButton.destroy();
        swanButton = null;
        failBack();
      }
    });
  };

  createButton();
  swan.login({
    success: function success(res) {
      console.log("swan.login", res);

      if (res.code) {
        code = res.code;
        createButton();
      } else {
        console.log("swan login fail");
      }
    },
    fail: function fail(err) {
      console.log(err);
    }
  });
};

var connectClose = function connectClose() {
  if (swanButton) {
    swanButton.destroy();
    swanButton = null;
  }
};
/****************** 立即执行 ******************/


_emitter.default.global.add("ptfromUser", function (param) {
  successBack = param.success;
  failBack = param.fail;
  swanLogin();
  return true;
}); //通讯事件监听


_connect.default.notify.add("close", connectClose);
})