define("libs/ni/fs",function(require,exports,module){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _http = _interopRequireDefault(require("libs/ni/http"));

var _util = _interopRequireDefault(require("libs/ni/util"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/****************** 导出 ******************/
var Fs =
/*#__PURE__*/
function () {
  function Fs() {
    _classCallCheck(this, Fs);
  }

  _createClass(Fs, null, [{
    key: "init",

    /**
     * @description 文件处理具体模块，根据不同平台匹配
     */

    /**
     * @description 创建fs的函数，由每个平台自己的fs模块设置
     */

    /**
     * @description depend处理对象
     */

    /**
     * @description 文件处理列表
     * @elements {method:"read"||"write",path:"",callback: Function}
     */

    /**
     * @description 缓存depend文件写入定时器
     */

    /**
     * @description 后缀名对应的Blob类型
     */

    /**
     * @description 初始化,根据cfg匹配不同平台处理文件对象
     */
    value: function init(cfg, callback) {
      Fs.appName = cfg.name;
      Fs.remote = cfg.appPath || cfg.remote + "/" + cfg.name;
      Fs.from = cfg.platForm;
      Fs.createFs(cfg, callback);
    }
    /**
     * @description 读文件,如果本地没有则去远端下载
     */

  }, {
    key: "read",
    value: function read(paths, callback, process) {
      var _this = this;

      var arr = Fs.depend.getFiles(paths, Fs.fs.except),
          fileMap = {},
          loaded = function () {
        var c = 0,
            total = arr.length;
        return function () {
          c += 1;
          process && process(c / total);

          if (c == total) {
            callback(fileMap);
          }
        };
      }(),
          deal = function deal(p, isLocal) {
        return function (err, data) {
          if (err) {
            return console.log(err);
          }

          var bt = _this.BlobType[_util.default.fileSuffix(p)] || "",
              ifont = bt.indexOf("font") > 0;
          fileMap[p] = data; // if(Util.fileSuffix(p) == ".png"){
          // 	console.log(typeof data);
          // }

          if (!isLocal) {
            Fs.fs.write(p, data, function (_err, rp) {
              if (_err) {
                return console.log(_err);
              }

              if (ifont && Fs.fs.addFont) {
                Fs.fs.addFont(p, data);
                delete fileMap[p];
              }

              loaded();
            });
          } else {
            if (ifont && Fs.fs.addFont) {
              Fs.fs.addFont(p, data);
              delete fileMap[p];
            }

            loaded();
          }
        };
      };

      for (var i = 0, len = arr.length; i < len; i++) {
        fileMap[arr[i]] = 0;

        if (Fs.fs.isLocal(arr[i], this.depend.all[arr[i]].sign)) {
          Fs.fs.read(arr[i], deal(arr[i], true));
        } else {
          if (Fs.fs.get && this.BlobType[_util.default.fileSuffix(arr[i])]) {
            Fs.fs.get(arr[i], Fs.remote, deal(arr[i], true));
          } else {
            _http.default.get("".concat(Fs.remote, "/").concat(arr[i]), "", this.BlobType[_util.default.fileSuffix(arr[i])] ? "BIN" : "", deal(arr[i], false));
          }
        }
      }

      return fileMap;
    }
    /**
     * @description 执行等待列表
     */

  }, {
    key: "runWait",
    value: function runWait() {
      if (Fs.waits.length === 0) {
        return;
      }
    }
    /**
     * @description 解析项目全资源表
     */

  }, {
    key: "parseDepend",
    value: function parseDepend(data) {
      Fs.depend = new Depend(data); // console.log(Fs.depend);
    }
    /**
     * @description 写缓存depend文件，方便查找是否已经存储到本地缓存
     */

  }, {
    key: "writeCacheDpend",
    value: function writeCacheDpend() {
      if (Fs.writeCacheDependTimer) {
        clearTimeout(Fs.writeCacheDependTimer);
      }

      Fs.writeCacheDependTimer = setTimeout(function () {
        Fs.fs.writeDepend(function () {});
        Fs.writeCacheDependTimer = null;
      }, 10000);
    }
    /**
     * @
     */

  }, {
    key: "mkDirs",
    value: function mkDirs() {
      if (Fs.fs && Fs.fs.mkDir) {
        for (var k in Fs.depend.dir) {
          Fs.fs.mkDir(k);
        }
      }
    }
  }]);

  return Fs;
}();
/****************** 本地 ******************/

/**
 * @description 解析depend
 */


exports.default = Fs;
Fs.remote = "";
Fs.appName = "";
Fs.from = "";
Fs.fs = void 0;
Fs.createFs = void 0;
Fs.depend = void 0;
Fs.waits = [];
Fs.writeCacheDependTimer = void 0;
Fs.BlobType = {
  ".png": 'image/png',
  ".jpg": 'image/jpeg',
  ".jpeg": 'image/jpeg',
  ".webp": 'image/webp',
  ".gif": 'image/gif',
  ".svg": 'image/svg+xml',
  ".ttf": 'application/x-font-ttf',
  ".otf": 'application/x-font-opentype',
  ".woff": 'application/x-font-woff',
  ".woff2": 'application/x-font-woff2',
  ".mp3": 'audio/mpeg3'
};

var Depend =
/*#__PURE__*/
function () {
  /**
   * @description 全资源列表，同depend文件，唯一去除了路径的"/"开头
   */

  /**
   * @description 文件夹资源列表
   * @element dir: [file,file,...]
   */
  function Depend(data) {
    _classCallCheck(this, Depend);

    this.all = {};
    this.dir = {};
    var p, d;

    for (var k in data) {
      p = k.replace("/", "");
      this.all[p] = data[k];
      data[k].path = p;

      if (data[k].depends) {
        for (var i = 0, len = data[k].depends.length; i < len; i++) {
          data[k].depends[i] = data[k].depends[i].replace("/", "");
        }
      }

      d = p.replace(/[^\/]+$/, "");
      this.adddir(d);

      if (d) {
        this.dir[d].push(p);
      }
    }
  }

  _createClass(Depend, [{
    key: "adddir",
    value: function adddir(d) {
      var ds = d.split("/"),
          curr = "",
          next = "";

      for (var i = 0, len = ds.length; i < len; i++) {
        if (!ds[i]) {
          continue;
        }

        curr += "".concat(ds[i], "/");

        if (!this.dir[curr]) {
          this.dir[curr] = [];
        }

        if (ds[i + 1]) {
          next = curr + "".concat(ds[i + 1], "/");

          if (this.dir[curr].indexOf(next) >= 0) {
            continue;
          }

          this.dir[curr].push(next);
        }
      }
    }
    /**
     * @description 获取文件
     * @param arr 路径或者目录组成的数组
     */

  }, {
    key: "getFiles",
    value: function getFiles(arr, except) {
      var _this2 = this;

      var r = [],
          dir = function dir(_arr) {
        for (var i = 0, len = _arr.length; i < len; i++) {
          if (_this2.dir[_arr[i]]) {
            dir(_this2.dir[_arr[i]]);
          } else if (except.indexOf(_util.default.fileSuffix(_arr[i])) < 0) {
            r.push(_arr[i]);
          }
        }
      };

      dir(arr);
      return r;
    }
    /**
     * @description 寻找模块依赖
     */

  }, {
    key: "findModDepend",
    value: function findModDepend(path, _arr) {
      var _this3 = this;

      var arr = _arr || [],
          file,
          find = function find(src) {
        for (var i = src.length - 1; i >= 0; i--) {
          file = _this3.all[src[i]];

          if (file.depends && file.depends.length) {
            find(file.depends);
          }

          if (arr.indexOf(src[i]) < 0) {
            arr.push(src[i]);
          }
        }
      };

      find([path]);
      return arr;
    }
  }]);

  return Depend;
}();
})