define("libs/wx/rank",function(require,exports,module){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _frame = _interopRequireDefault(require("libs/ni/frame"));

var _emitter = _interopRequireDefault(require("libs/ni/emitter"));

var _scene = _interopRequireDefault(require("libs/ni/scene"));

var _connect = _interopRequireDefault(require("libs/ni/connect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/****************** 导出 ******************/
var Rank =
/*#__PURE__*/
function () {
  function Rank() {
    _classCallCheck(this, Rank);
  }

  _createClass(Rank, null, [{
    key: "init",
    value: function init(cfg) {
      sendMessage({
        type: "screen",
        screen: cfg.screen
      });
      screen = cfg.screen;
    }
  }]);

  return Rank;
}();
/****************** 本地 ******************/


exports.default = Rank;
var rankNode,
    screen,
    fastRang,
    utStep = 300,
    lastStep = utStep,
    updataTimer = Date.now() + utStep;
/**
 * @description 向微信子域发消息
 * @param message 
 */

var sendMessage = function sendMessage(message) {
  var openDataContext = wx.getOpenDataContext();
  openDataContext.postMessage(message);
};

var setScore = function setScore(score) {
  sendMessage({
    type: 'updateScore',
    value: score
  });
};

var update = function update() {
  var n = Date.now();

  if (!rankNode || n < updataTimer) {
    return;
  }

  updataTimer = n + utStep;
  lastStep += 300;
  var sharedCanvas = window['sharedCanvas'];

  var texture = _scene.default.createCanvasTexture(sharedCanvas);

  rankNode.texture = texture;

  if (!fastRang || !fastRang.init) {
    utStep = lastStep;
  }
};

var connectClose = function connectClose() {
  if (!rankNode) {
    return;
  }

  _scene.default.remove(rankNode);

  rankNode = undefined;
};

var caclFastRang = function caclFastRang(x, y, w, h) {
  fastRang = {
    x: x,
    y: y,
    w: w,
    h: h
  }; // console.log(fastRang);
};

var touchStart = function touchStart(e) {
  // console.log(e,fastRang)
  if (!fastRang || fastRang.init) {
    return;
  }

  fastRang.init = true; // console.log(e);

  var touch = e.start;

  if (touch.y > fastRang.y && touch.x > fastRang.x && touch.y < fastRang.y + fastRang.h && touch.x < fastRang.x + fastRang.w) {
    // console.log("yes!");
    utStep = 30;
    updataTimer = Date.now() + utStep;
  }
};

var touchEnd = function touchEnd(e) {
  // console.log(e);
  if (!fastRang) {
    return;
  }

  utStep = lastStep;
  fastRang.init = undefined;
  sendMessage({
    type: "onTouchEnd"
  });
};
/****************** 立即执行 ******************/


_emitter.default.global.add("ptRank", function () {
  return true;
});

_emitter.default.global.add("newScore", function (score) {
  setScore(score);
  utStep = lastStep = 300;
});

_emitter.default.global.add("ptRankTop", function () {
  connectClose();
  var sharedCanvas = window['sharedCanvas'],
      scale;
  sendMessage({
    type: "ptRankTop"
  }); // console.log(sharedCanvas.a);

  var app = _scene.default.app(),
      texture = _scene.default.createCanvasTexture(sharedCanvas);

  rankNode = _scene.default.createSpriteFromTexture(texture, app.stage);
  scale = 576 / texture.frame.width; // console.log(rankNode);

  rankNode.width = 576;
  rankNode.height = texture.frame.height * scale;
  rankNode.x = (screen.width - 576) / 2;
  rankNode.y = 513;
});

_emitter.default.global.add("ptRankAll", function () {
  connectClose();
  var sharedCanvas = window['sharedCanvas'],
      scale;
  sendMessage({
    type: "ptRankAll"
  }); // console.log(sharedCanvas.a);

  var app = _scene.default.app(),
      texture = _scene.default.createCanvasTexture(sharedCanvas);

  rankNode = _scene.default.createSpriteFromTexture(texture, app.stage);
  scale = 608 / texture.frame.width; // console.log(rankNode);

  rankNode.width = 608;
  rankNode.height = texture.frame.height * scale;
  rankNode.x = (screen.width - 608) / 2;
  rankNode.y = 274;
  caclFastRang(rankNode.x, rankNode.y, rankNode.width, rankNode.height - 176);
});

_emitter.default.global.add("ptRankClose", function () {
  // console.log("ptRankClose");
  _scene.default.remove(rankNode);

  rankNode = undefined;
  fastRang = undefined;
});

_emitter.default.global.add("rankTouchStart", function (e) {
  touchStart(e);
  return true;
});

_emitter.default.global.add("rankTouchEnd", function (e) {
  touchEnd(e);
  return true;
});

_frame.default.add(update); //通讯事件监听


_connect.default.notify.add("close", connectClose);
})